package owg.lgm.ar1;

import owg.lgm.*;
import owg.lgm.ar1.accessories.AR1Dialog;
import owg.lgm.ar1.accessories.AR1Fonts;
import owg.lgm.ar1.gates1.*;
import owg.lgm.ar1.ingredianser.Ingnr6;
import owg.lgm.ar1.newgates.*;
import owg.lgm.ar1.nygatess.*;
import owg.lgm.ar1.kyz.*;
import owg.lgm.ar1.lava.Badlava;
import owg.lgm.ar1.enemy.*;
import owg.lgm.ar1.stuff.boss.*;
import owg.lgm.ar1.stuff.evilballstuf.*;
import owg.lgm.ar1.stuff.animals.*;
import owg.lgm.ar1.stuff.telefon.*;
import owg.lgm.ar1.stuff.buton.*;
import owg.lgm.ar1.stuff.special.*;
import owg.lgm.ar1.stuff.gatenot.*;
import owg.lgm.ar1.stuff.back.*;
import owg.lgm.ar1.explodd.*;
import owg.lgm.ar1.fakedollidd.Immetdest;
import owg.lgm.ar1.fakedollidd.Misksolid;
import owg.lgm.ar1.stuff.draw.Back;
import owg.lgm.ar1.stuff.draw.Fordraw;
import owg.lgm.in.KeyEventType;
import owg.lgm.in.KeyListener;
import owg.lgm.in.VK;
import owg.lgm.room.Room;
import owg.lgm.room.Room.BackgroundData;

import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.ar1.accessories.AR1Scripts.*;

import static owg.lgm.GMLib.*;

public class Animal extends Entity implements Collider, KeyListener
{
	public Animal(double x, double y)
	{
		super(x, y, 0, false, false, false, "ystandl", null);
	}
	protected Animal(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
	{
		super(x, y, depth, persistent, visible, solid, sprite, mask);
	}

	public int still;
	public int right;

	int nomv, inv, hy;
	double life;

	@Override
	public void createEvent()
	{
		visible = true;
		alarm[6] = (short)(45);
		if (instance_number(Back.class)==0)
		{
			instance_create(0,0,Back.class);
			instance_create(0,0,Fordraw.class);
		}
		
		if(global.set == 0) {
			instance_create(0,0,Muzika.class);
			instance_create(0,0,Exitnot.class);
		}

		{
			BackgroundData background7 = Room.CURRENT.backgrounds[7];
			background7.visible = true;
			background7.setBackgroundName("blackplack");
			background7.foreground = true;
			alarm[4] = 5;
		}
		initSprite();
		vspeed=0;
		global.jsped = 9;
		friction=0.30;
		{
			gravity=0.50;
			gravity_direction=270;
		}
		right = 1;
		image_speed = 0.1;
		nomv = 0;
		still = 0;
		inv = 0;
		life = 6;
		hy = 0;
	}


	public void start()
	{
		initSprite();
		alarmTriggered(4);
		instance(Muzika.class).step();
	}

	public void initSprite()
	{
		if (global.cha==0)
		{
			sprite = Sprite.get("ystandr");
			image_xscale=1;
			image_yscale=1;
		}
		if (global.cha==1)
		{
			sprite = Sprite.get("kstandr");
			image_xscale=1;
			image_yscale=1;
		}
		if (global.cha==2)
		{
			sprite = Sprite.get("fsr");
			image_xscale=1;
			image_yscale=1;
		}
	}

	@Override
	public void beginStep()
	{
		if (global.set==0)
		{
			showMainMenu();
		}
	}

	@Override
	public void step()
	{
		if (global.savedud==1)
			instance_create(x+0,y+0,Follothing.class);
		if (global.life<0)
		{
			sound_play("screem");
			instance_create(x+0,y+0,Deaddy.class);
		}
		if (inv>0)
		{
			inv += -1;
			visible = !visible;
		}
		else
			visible = true;
		if (x<sprite_width()/2.0)
		{
			x = xprevious;
			x+=8;
			hspeed=-hspeed;
		}
		if (x>room_width()-sprite_width()/2.0)
		{
			x = xprevious;
			x+=-8;
			hspeed=-hspeed;
		}
	}
	@Override
	public void gameStart()
	{
		global.objbjbj = 0;
		//Yho Hav Bin
		global.elembeen = 0;
		global.downbeen = 0;
		global.rightbeen = 0;
		global.hiddentownbeen = 0;
		global.cavetownbeen = 0;
		global.jungletownbeen = 0;
		global.bluecavebeen = 0;
		global.metalbeen = 0;
		global.minebeen = 0;
		global.stairbeen = 0;
		global.lavabeen = 0;
		global.topbeen = 0;
		global.mountainbeen = 0;
		global.junglebeen = 0;
		//Startornot
		global.set = 0;
		//Life
		global.life = 128;
		global.maxlife = 128;
		global.maxlifelev = 4;
		//Potions
		global.potion[0] = 3;
		global.potionname[0] = "Potion";
		global.potion[1] = 1;
		global.potionname[1] = "Full Health";
		global.potion[2] = 0;
		global.potionname[2] = "Increase MaxHealth";
		global.potion[3] = 1;
		global.potionname[3] = "Extra Strength";
		global.potion[4] = 1;
		global.potionname[4] = "Cure Sickness";
		global.potion[5] = 0;
		global.potionname[5] = "Poison";
		//Potions
		global.potioncost[0] = 10;
		global.potioncost[1] = 25;
		global.potioncost[2] = 20;
		global.potioncost[3] = 40;
		global.potioncost[4] = 35;
		global.potioncost[5] = 15;
		//Sickstuff
		global.poisoned = 0;
		//Claws
		global.sharpness = 4;
		global.sharpreal = 4;
		//Money
		global.score = 100;
		//Moveornot
		global.uxyz = -1;
		//otha
		global.eatn = 0;
		global.ayyy = 0;
		global.axxx = 0;
		global.controlc = 0;
		global.destroyc = 0;
		global.createc = 0;
		global.gravityc = 0;
		global.reactdeadevil = 0;
		global.elementye = 0;
		global.guyran = 0;
		global.element4 = 0;
		global.element3 = 0;
		global.element2 = 0;
		global.element1 = 0;
		global.spockn7 = 0;
		global.gsgfhfs = 0;
		global.robopartsouv = 0;
		global.abzolniu = 0;
		global.blackmushz = 0;
		global.nobo = 0;
		global.blunuky3 = 0;
		global.blunuky2 = 0;
		global.blunuky1 = 0;
		global.thekicard = 0;
		global.spoken = 0;
		global.spoken3 = 0;
		global.batters = 0;
		global.butprs = 0;
		global.smcavseald = 0;
		global.bigknew1 = 0;
		global.bigknew2 = 0;
		global.bigknew3 = 0;
		global.nwhathevva = 0;
		global.bigknewblu3 = 0;
		global.bigknewblu2 = 0;
		global.bigknewblu1 = 0;
		global.bigk1 = 0;
		global.bigk2 = 0;
		global.bigk3 = 0;
		global.bigk4 = 0;
		global.itemtaken1 = 0;
		global.itemtaken2 = 0;
		global.itemtaken4 = 0;
		global.itemtaken3 = 0;
		global.itemtaken5 = 0;
		global.itemtaken6 = 0;
		global.mineopen = 0;
		global.mineopen2 = 0;
		global.mineopen3 = 0;
		global.onebossdef = 0;
		global.keys = 0;
		global.newkeytak2 = 0;
		global.newkeytak1 = 0;
		global.newkeytak4 = 0;
		global.newkeytak3 = 0;
		global.keytak1 = 0;
		global.keytak2 = 0;
		global.keytak3 = 0;
		global.keytak4 = 0;
		global.opendjung = 0;
		global.savedud = 0;
		global.opennew = 0;
		global.spooken2 = 0;
		global.spooken5 = 0;
		global.blueplac = 0;
		global.inngrodd1 = 0;
		global.inngrodd2 = 0;
		global.inngrodd3 = 0;
		global.inngrodd4 = 0;
		global.inngrodd5 = 0;
		global.inngrodd6 = 0;
		global.oddkey1 = 0;
		global.oddkey3 = 0;
		global.oddkey2 = 0;
		global.newtown = 0;
		global.opennewye3 = 0;
		global.opennewye4 = 0;
	}
	@Override
	public void outsideRoom()
	{
		if (y>room_height())
		{
			System.err.println("Out of bounds :(");
			transition_kind(0);
			room_restart();
		}
		if (y<0)
		{
			y=yprevious+1;
			vspeed=-vspeed;
		}
	}
	@Override
	public void alarmTriggered(int alarmIndex)
	{
		switch (alarmIndex)
		{
		case 0:
			//STOP!
			if (!place_free(x+0,y+vspeed+1))
			{
				if (hspeed>-1 && hspeed<1)
				{
					image_speed = 0.1;
					if (global.cha==0)
					{
						if (right==1)
						{
							sprite = Sprite.get("ystandr");
							image_xscale=1;
							image_yscale=1;
						}
						else
						{
							sprite = Sprite.get("ystandl");
							image_xscale=1;
							image_yscale=1;
						}
					}
					if (global.cha==1)
					{
						if (right==1)
						{
							sprite = Sprite.get("kstandr");
							image_xscale=1;
							image_yscale=1;
						}
						else
						{
							sprite = Sprite.get("kstandl");
							image_xscale=1;
							image_yscale=1;
						}
					}
					if (global.cha==2)
					{
						if (right==1)
						{
							sprite = Sprite.get("fsr");
							image_xscale=1;
							image_yscale=1;
						}
						else
						{
							sprite = Sprite.get("fsl");
							image_xscale=1;
							image_yscale=1;
						}
					}
				}
				else
				{
					image_speed = getSpeed()/3.0;
					alarm[0] = (short)(2);
				}
			}
			else
				alarm[0] = (short)(2);
			break;
		case 1:
			//crouch
			if (global.cha==0)
			{
				if (right==1)
				{
					sprite = Sprite.get("ylier");
					image_xscale=1;
					image_yscale=1;
				}
				else
				{
					sprite = Sprite.get("yliel");
					image_xscale=1;
					image_yscale=1;
				}
			}
			if (global.cha==1)
			{
				if (right==1)
				{
					sprite = Sprite.get("klier");
					image_xscale=1;
					image_yscale=1;
				}
				else
				{
					sprite = Sprite.get("kliel");
					image_xscale=1;
					image_yscale=1;
				}
			}
			if (global.cha==2)
			{
				if (right==1)
				{
					sprite = Sprite.get("flier");
					image_xscale=1;
					image_yscale=1;
				}
				else
				{
					sprite = Sprite.get("fliel");
					image_xscale=1;
					image_yscale=1;
				}
			}
			break;
		case 2:
			//Reset or  something
			friction=0.30;
			{
				gravity=0.50;
				gravity_direction=270;
			}
			image_speed = 0.1;
			nomv = 0;
			still = 0;
			hspeed=0;
			if (global.cha==0)
			{
				sprite = Sprite.get("ystandr");
				image_xscale=1;
				image_yscale=1;
			}
			if (global.cha==1)
			{
				sprite = Sprite.get("kstandr");
				image_xscale=1;
				image_yscale=1;
			}
			if (global.cha==2)
			{
				sprite = Sprite.get("fsr");
				image_xscale=1;
				image_yscale=1;
			}
			vspeed=0;
			break;
		case 3:
			hy = 0;
			break;
		case 4:
			alarm[4] = 0;
			Room.CURRENT.backgrounds[7].visible = false;
			if (global.gsgfhfs==1)
			{
				global.gsgfhfs = 2;
				still = 1;
				instance_create(x+32,y+0,Object529.class);
				alarm[7] = (short)(160);
			}
			if (global.uxyz!=-1)
			{
				x=global.hex[global.uxyz];
				y=global.hey[global.uxyz]-1;
			}
			if (global.axxx>0)
			{
				{
					x=global.axxx;
					y=global.ayyy;
				}
				global.ayyy = 0;
				global.axxx = 0;
			}
			if (x>room_width()/2.0)
			{
				right = 0;
				if (global.cha==0)
				{
					sprite = Sprite.get("ystandl");
					image_xscale=1;
					image_yscale=1;
				}
				if (global.cha==1)
				{
					sprite = Sprite.get("kstandl");
					image_xscale=1;
					image_yscale=1;
				}
				if (global.cha==2)
				{
					sprite = Sprite.get("fsl");
					image_xscale=1;
					image_yscale=1;
				}
			}
			if (global.destroyc>0 || global.createc>0)
				instance_create(0,0,Destcret.class);

			global.set = 1;
			
			if(global.town) {
				Room.CURRENT.views[0].xview = (int) (x-320);
				Room.CURRENT.views[0].yview = (int) (y-320);
				Room.CURRENT.render();
				save();
				instance_create(0,0,SaveNotify.class);
			}
			break;
		case 5:
			still = 0;
			{
				gravity=0.50;
				gravity_direction=270;
			}
			break;
		case 6:
			if (global.poisoned==1)
				if (global.life>17)
					global.life += -1;
			alarm[6] = (short)(60);
			if (global.life<32)
				global.life += 1;
			break;
		case 7:
			new AR1Dialog()
			{
				@Override
				public void dialog() throws ConverseException, SleepException
				{
					show_message("Evil guy: I hate you all... You have ruined my plan.");
					Object529 other = instance(Object529.class);
					{
						{
							other.sprite = Sprite.get("evilself");
							other.image_xscale=1;
							other.image_yscale=1;
						}
					}
					sleep(200);
					other.alarm[0] = (short)(15);
				}
			}.start();
			break;
		default:
			super.alarmTriggered(alarmIndex);
			break;
		}
	}

	protected void goIn(int millis, String room)
	{
		new AR1Dialog()
		{

			@Override
			public void dialog() throws ConverseException, SleepException
			{
				sleep(millis);
				transition_kind(0);
				room_goto(room);
			}
		}.start();
	}

	@SuppressWarnings("unused")
	@Override
	public void handleCollisions()
	{
		for(Briggd other : getCollisions(Briggd.class))
		{
			if (y<other.y+16)
			{
				double maxdist = Math.abs(vspeed);
				vspeed=0;
				y=other.y;
				double yprev = y;
				{
					move_contact_all(270, maxdist);
				}
				if (y>yprev+32)
					y = yprev;
			}
			if(isDisposed())
				return;
		}
		for(Brigd2 other : getCollisions(Brigd2.class))
		{
			if (place_meeting(x+0, y+24, Brigd2.class))
			{
				vspeed=-hspeed/2;
				vspeed+=-gravity-friction;
			}
			if (!place_free(x+0,y+-16))
				vspeed+=-1;
			if(isDisposed())
				return;
		}
		for(Brigd3 other : getCollisions(Brigd3.class))
		{
			if (place_meeting(x+0, y+24, Brigd3.class))
			{
				vspeed=hspeed/2;
				vspeed+=-gravity-friction;
			}
			if (!place_free(x+0,y+-16))
				vspeed+=-1;
			if(isDisposed())
				return;
		}

		for(Diagr other : getCollisions(Diagr.class))
		{
			vspeed=hspeed/2;
			vspeed+=-gravity-friction;
			if(isDisposed())
				return;
		}
		for(Diagl other : getCollisions(Diagl.class))
		{
			vspeed=-hspeed/2;
			vspeed+=-gravity-friction;
			if(isDisposed())
				return;
		}
		for(Ground other : getCollisions(Ground.class))
		{
			move_bounce_solid(false);
			if(isDisposed())
				return;
		}
		for(Top other : getCollisions(Top.class))
		{
			if (y<other.y+36)
			{
				double maxdist = Math.abs(vspeed);
				vspeed=0;
				y=other.y;
				double yprev = y;
				move_contact_solid(270, maxdist);
				if (y>yprev+32)
					y = yprev;
				else
					yprevious = y;
			}
			else
				move_bounce_solid(false);
			if(isDisposed())
				return;
		}
		for(Bigruung other : getCollisions(Bigruung.class))
		{
			move_bounce_solid(false);
			if(isDisposed())
				return;
		}
		for(Object189 other : getCollisions(Object189.class))
		{
			move_bounce_solid(false);
			if (hy==0)
			{
				hy = 1;
				alarm[3] = 60;
				AR1Dialog.simple_message("A broken down mine. It is closed.");
			}
			if(isDisposed())
				return;
		}
		for(Innshopin other : getCollisions(Innshopin.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					global.uxyz = -1;
					{
						transition_kind(0);
						room_goto("innanshop");
					}
				}
			if(isDisposed())
				return;
		}
		for(Innkeper other : getCollisions(Innkeper.class))
		{
			if (hspeed>0)
			{
				if (hy==0)
				{
					hy = 1;
					alarm[3] = 90;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (show_question("Do you want to rest here? It costs 10 valuables."))
							{
								if (global.score>9)
								{
									still = 1;
									alarm[5] = 80;
									other.a = 1;
									global.score += -10;
								}
								else
									show_message("You dont have enough money.");
							}
							else
								show_message("Come back later!");
						}
					}.start();
				}
			}
			if(isDisposed())
				return;
		}
		for(Innshopex other : getCollisions(Innshopex.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					global.uxyz = 1;
					{
						transition_kind(0);
						room_goto("town");
					}
				}
			if(isDisposed())
				return;
		}
		for(Barseller other : getCollisions(Barseller.class))
		{
			alarm[3] = 2;
			if (hspeed>0)
			{
				if (hy==0)
				{
					hy = 1;
					new AR1Dialog()
					{
						@Override
						public void dialog() throws ConverseException, SleepException
						{
							int itemm=show_menu("Do you want to buy something?",
									"No",
									"Potion ("+global.potion[0]+") cost 10",
									"Full Health ("+global.potion[1]+") cost 25",
									"Increase MaxHealth ("+global.potion[2]+") cost 20",
									"Extra Strength ("+global.potion[3]+") cost 40",
									"Cure Sickness ("+global.potion[4]+") cost 35",
									"Poison ("+global.potion[5]+") cost 15");
							if (itemm==0)
								show_message("Come back later!");
							else
							{
								itemm += -1;
								if (show_question("Purchase " + (global.potionname[itemm])+"?"))
								{
									if (global.score>global.potioncost[itemm]-1)
									{
										show_message("You bought " + (global.potionname[itemm])+".");
										global.score += -global.potioncost[itemm];
										global.potion[itemm] += 1;
									}
									else
										show_message("You dont have enough money.");
								}
								else
									show_message("Come back later!");
							}
						}
					}.start();
				}
			}
			if(isDisposed())
				return;
		}
		for(Barinn other : getCollisions(Barinn.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					global.uxyz = -1;
					{
						transition_kind(0);
						room_goto("indabar");
					}
				}
			if(isDisposed())
				return;
		}
		for(Barexx other : getCollisions(Barexx.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 4;
				{
					transition_kind(0);
					room_goto("town");
				}
			}
			if(isDisposed())
				return;
		}
		for(Noentr other : getCollisions(Noentr.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					AR1Dialog.simple_message("Closed");
				}
			if(isDisposed())
				return;
		}
		for(Valuer5 other : getCollisions(Valuer5.class))
		{
			other.destroy();
			global.score += 5;
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Valuer15 other : getCollisions(Valuer15.class))
		{
			other.destroy();
			global.score += 15;
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Goout other : getCollisions(Goout.class))
		{
			global.uxyz = 0;
			{
				transition_kind(0);
				room_goto("dadesert");
			}
			if(isDisposed())
				return;
		}
		for(Gototown other : getCollisions(Gototown.class))
		{
			global.uxyz = 5;
			goIn(1000, "town");
			if(isDisposed())
				return;
		}
		for(Enemy1 other : getCollisions(Enemy1.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				other.inv = 30;
				other.life += -global.sharpness;
				if (other.life<0)
				{
					instance_create(other.x+17,other.y+0,Explodd2.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Enmy1basll other : getCollisions(Enmy1basll.class))
		{
			if(other instanceof En9was)
			{
				if (inv<1)
				{
					if (y>other.y)
					{
						global.life += -other.damage;
						sound_play("ough");
						inv = 45;
						hspeed+=other.hspeed;
						vspeed+=other.vspeed;
					}
					else
					{
						other.destroy();
						vspeed=-vspeed;
					}
				}
			}
			else if(other instanceof Enrwas)
			{
				hspeed+=2;
				x+=8;
				if (inv<1)
				{
					global.life += -other.damage;
					sound_play("ough");
					inv = 45;
					hspeed+=other.hspeed;
					vspeed+=other.vspeed;
				}
			}
			else if (inv<1)
			{
				global.life += -other.damage;
				sound_play("ough");
				inv = 45;
				hspeed+=other.x-other.xprevios;
				vspeed+=other.y-other.yprevios;
			}
			if(isDisposed())
				return;
		}
		for(Poisarrw other : getCollisions(Poisarrw.class))
		{
			if (inv<1)
			{
				other.destroy();
				global.life += -other.damage;
				sound_play("ough");
				inv = 45;
				hspeed+=other.hspeed;
				vspeed+=other.vspeed;
				global.poisoned = 1;
			}
			if(isDisposed())
				return;
		}
		for(Shotblb1 other : getCollisions(Shotblb1.class))
		{
			if (inv<1)
			{
				other.destroy();
				global.life += -other.damage;
				sound_play("ough");
				inv = 45;
				hspeed+=other.hspeed;
				vspeed+=other.vspeed;
			}
			if(isDisposed())
				return;
		}
		for(Enemy2 other : getCollisions(Enemy2.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				other.inv = 30;
				other.life += -global.sharpness;
				if(other.life < 0)
				{
					instance_create(other.x+17,other.y+0,Explodd2.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Keylayout1 other : getCollisions(Keylayout1.class))
		{
			global.keytak1 = 1;
			global.keys += 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Keylayout2 other : getCollisions(Keylayout2.class))
		{
			global.keytak2 = 1;
			global.keys += 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Keylayout3 other : getCollisions(Keylayout3.class))
		{
			global.keytak3 = 1;
			global.keys += 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Keylayout4 other : getCollisions(Keylayout4.class))
		{
			global.keytak4 = 1;
			global.keys += 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Needkii other : getCollisions(Needkii.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					AR1Dialog.simple_message("You need a key to enter.");
				}
			if(isDisposed())
				return;
		}
		for(Gotobacdes other : getCollisions(Gotobacdes.class))
		{
			global.uxyz = 1;
			{
				transition_kind(0);
				room_goto("dadesert");
			}
			if(isDisposed())
				return;
		}
		for(Gotomount other : getCollisions(Gotomount.class))
		{
			global.uxyz = 0;
			{
				transition_kind(0);
				room_goto("themountain");
			}
			if(isDisposed())
				return;
		}
		for(Dorofbos other : getCollisions(Dorofbos.class))
		{
			x=xprevious+8;
			hspeed=-hspeed;
			if(isDisposed())
				return;
		}
		for(Boss1 other : getCollisions(Boss1.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				other.inv = 30;
				other.life += -global.sharpness;
				if(other.life < 0)
				{
					instance_create(other.x+17,other.y+0,Explodd3.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Standomen other : getCollisions(Standomen.class))
		{
			double hiu = other.x-other.xprevios;
			double viu = other.y-other.yprevios;
			if (!(place_meeting(x+hiu*3, y+viu*3, Ground.class)))
				if (!(place_meeting(x+hiu*3, y+viu*3, Top.class)))
				{
					if (other.vspeed>0)
					{
						vspeed=-gravity-friction+1+viu;
						{
							x=x+hiu;
							y=other.y+viu+2;
						}
					}
					else
					{
						vspeed=-gravity-friction+2;
						{
							x=x+hiu;
							y=other.y+2;
						}
					}
				}
			if(isDisposed())
				return;
		}
		for(Goleftmount other : getCollisions(Goleftmount.class))
		{
			if (instance_number(Keylayout2.class)==0)
			{
				global.uxyz = 1;
				{
					transition_kind(0);
					room_goto("themountain");
				}
			}
			if(isDisposed())
				return;
		}
		for(Gotobosson other : getCollisions(Gotobosson.class))
		{
			global.uxyz = -1;
			{
				transition_kind(0);
				room_goto("bossright1");
			}
			if(isDisposed())
				return;
		}
		for(Maspeakw other : getCollisions(Maspeakw.class))
		{
			alarm[3] = 3;
			if (hy==0)
			{
				new AR1Dialog()
				{
					final boolean first = other.sprite.name.equals("orangisl");
					final boolean badlyHurt = global.life<global.maxlife/4;
					boolean healed = false;

					@Override
					public void dialog() throws ConverseException, SleepException
					{

						if (global.abzolniu>0)
						{
							show_message("You have saved us! The world has become safe again!");
							if (global.gsgfhfs<2)
							{
								show_message("I sense there is some evil left though. Its very weak, I dont know if its anything...");
								show_message("I thing you should search over the world for places you have not been and speak with animals.");
							}
							else
								show_message("I see you have defeated the animal behind the evil also.");
							global.poisoned = 0;
							global.life = global.maxlife;
							sound_play("monny");
							hy = 1;
						}
						else
						{
							hy = 1;
							if (first)
							{
								show_message("Oh, I didnt see you coming!");
								show_message("Hello, "+(global.name)+"!");
								other.sprite = Sprite.get("sprite192");
								other.image_xscale=1;
								other.image_yscale=1;
								sleep(1000);

								show_message("You can call me some kind of oracle.");
								if (show_question("Do you want my advice in your situation?"))
								{
									show_message("You will have to gather 4 big keys; all in different shapes. They are shattered and hidden in rooms with doors that leads to the pieces.");
									show_message("When you have gathered the pieces of a key, something usually opens. When all keys are gathered, you will be able to use a special weapon.");
									show_message("It woint be easy, dangers lies everywhere.");
									if (badlyHurt)
									{
										show_message("You are quite badly hurt. I can help you a bit.");
										show_message("You have restored 32 health points.");
										if(!healed)
										{
											sound_play("monny");
											global.life += 32;
											healed = true;
										}
										sleep(500);

									}
									else
									{
										if (global.life<global.maxlife/2)
											show_message("You should heal yourself.");
									}
									if (global.keytak1==0)
										show_message("You can find a key to something if you move right through the desert.");
									if (global.onebossdef==0)
										show_message("There is a big evil machine if you move right through the desert.");
									else
									{
										if (global.mineopen==0)
										{
											show_message("You have defeated the big evil machine to the east.");
											show_message("You can now enter the mines to the west.");
										}
										if (global.mineopen<2)
										{
											show_message("Search the mine and find the secret doors.");
											show_message("The keys you have found are for those doors.");
											show_message("They are portals to famillar places and places noone have been.");
											show_message("If you move through the mine you will find a place unknown to me.");
										}
										else
										{
											show_message("You have been in the room with the doors.");
											if (global.keys < 4)
											{
												show_message("You should find the rest of the keys.");
												if (global.keytak3==0 && global.keytak4==1)
												{
													if (global.keytak1==0)
														show_message("One of the keys remaining is in the mine.");
													else
														show_message("The remaining key is in the mine.");
												}
												if (global.keytak3==0 && global.keytak4==1)
												{
													if (global.keytak1==0)
														show_message("One of the keys remaining is in the mine.");
													else
														show_message("The remaining key is in the mine.");
												}
												if (global.keytak3==0 && global.keytak4==0)
												{
													if (global.keytak1==0)
														show_message("Two of the keys remaining is in the mine.");
													else
														show_message("The two keys remaining is in the mine.");
												}
											}
											else
											{
												if (global.opendjung==0)
												{
													show_message("Every door has a piece of a big key inside.");
													if (global.bigk1==1 && global.bigk2==1 && global.bigk3==1 && global.bigk4==1)
														show_message("Go to the room of doors and let the big key open your door.");
													else
														show_message("You should find all pieces of the big key.");
												}
												else
													show_message("Go through the opened door in the room of doors into the jungle. There I cannot guide you no more.");
											}
										}
									}
									show_message("I have no more advice for you.");
								}
								else
								{
									other.sprite = Sprite.get("orangisl");
									other.image_xscale=1;
									other.image_yscale=1;
									show_message("Goodbye then!");
								}
							}
							else
								show_message("Come back later");
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Gotoshuse other : getCollisions(Gotoshuse.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				{
					transition_kind(0);
					room_goto("keyhoused1");
				}
			}
			if(isDisposed())
				return;
		}
		for(Gooutofhus other : getCollisions(Gooutofhus.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 3;
				{
					transition_kind(0);
					room_goto("town");
				}
			}
			if(isDisposed())
				return;
		}
		for(Skippn3 other : getCollisions(Skippn3.class))
		{
			if (inv<1)
			{
				global.life += -other.damage;
				sound_play("ough");
				inv = 45;
				hspeed+=other.hspeed;
				vspeed+=other.vspeed;
			}
			if(isDisposed())
				return;
		}
		for(Enemy3 other : getCollisions(Enemy3.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				other.inv = 30;
				other.life += -global.sharpness;
				if(other.life < 0)
				{
					instance_create(other.x+17,other.y+0,Explodd2.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Goincaved other : getCollisions(Goincaved.class))
		{
			global.uxyz = 0;
			goIn(1000, "theminein");
			if(isDisposed())
				return;
		}
		for(Gotowncsv other : getCollisions(Gotowncsv.class))
		{
			global.uxyz = 0;
			goIn(1000, "town");
			if(isDisposed())
				return;
		}
		for(Portback other : getCollisions(Portback.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					alarm[3] = 30;
					hy = 1;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							show_message("The portal leads to town.");
							if (show_question("Enter?"))
							{
								global.uxyz = 6;
								{
									transition_kind(0);
									room_goto("town");
								}
							}
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Toports other : getCollisions(Toports.class))
		{
			global.uxyz = -1;
			goIn(1000, "portalkeys");
			if(isDisposed())
				return;
		}
		for(Fromports other : getCollisions(Fromports.class))
		{
			global.uxyz = 2;
			goIn(500, "theminein");
			if(isDisposed())
				return;
		}
		for(Teletoports other : getCollisions(Teletoports.class))
		{
			sound_play("tele");
			global.uxyz = -1;
			new AR1Dialog()
			{

				@Override
				public void dialog() throws ConverseException, SleepException
				{
					show_message("You have been teleported to the room of doors.");
					sleep(1000);

					{
						transition_kind(0);
						room_goto("portalkeys");
					}
				}
			}.start();
			if(isDisposed())
				return;
		}
		for(Gate1 other : getCollisions(Gate1.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.bigk1==1)
							show_message("You have finished your work there.");
						else
						{
							if (global.keytak1==1)
							{
								if (hy==0)
								{
									alarm[3] = 30;
									show_message("The portal leads to a dark place.");
									if (show_question("Enter?"))
									{
										global.uxyz = -1;
										hy = 1;
										{
											transition_kind(0);
											room_goto("darkplace");
										}
									}
									else
										hy = 1;
								}
							}
							else
								show_message("You need another key...");
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Gate2 other : getCollisions(Gate2.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.bigk2==0)
						{
							if (global.keytak2==1)
							{
								if (hy==0)
								{
									alarm[3] = 30;
									show_message("The portal leads to a dangerous place");
									if (show_question("Enter?"))
									{
										global.uxyz = -1;
										hy = 1;
										{
											transition_kind(0);
											room_goto("odoorboss");
										}
									}
									else
										hy = 1;
								}
							}
							else
								show_message("You need another key...");
						}
						else
							show_message("You have finished your work there.");
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Gate3 other : getCollisions(Gate3.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.bigk3==1)
							show_message("You have finished your work there.");
						else
						{
							if (global.keytak3==1)
							{
								if (hy==0)
								{
									alarm[3] = 30;
									show_message("The portal leads to a rather light place.");
									if (show_question("Enter?"))
									{
										global.uxyz = -1;
										hy = 1;
										{
											transition_kind(0);
											room_goto("leftofcave");
										}
									}
									else
										hy = 1;
								}
							}
							else
								show_message("You need another key...");
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Gate4 other : getCollisions(Gate4.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.bigk4==1)
							show_message("You have finished your work there.");
						else
						{
							if (global.keytak4==1)
							{
								if (hy==0)
								{
									alarm[3] = 30;
									show_message("The portal leads to a quiet place.");
									if (show_question("Enter?"))
									{
										global.uxyz = -1;
										hy = 1;
										{
											transition_kind(0);
											room_goto("wheelcaserd");
										}
									}
								}
							}
							else
								show_message("You need another key...");
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Yekgib1 other : getCollisions(Yekgib1.class))
		{
			global.bigk1 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Yekgib2 other : getCollisions(Yekgib2.class))
		{
			global.bigk2 = 1;
			other.destroy();
			sound_stop_all();
			sound_play("monny");
			sound_play("tele");
			global.uxyz = -1;
			new AR1Dialog()
			{
				@Override
				public void dialog() throws ConverseException, SleepException
				{
					show_message("You have been teleported to the room of doors.");
					sleep(1000);

					{
						transition_kind(0);
						room_goto("portalkeys");
					}
				}
			}.start();
			if(isDisposed())
				return;
		}
		for(Yekgib3 other : getCollisions(Yekgib3.class))
		{
			global.bigk3 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Yekgib4 other : getCollisions(Yekgib4.class))
		{
			global.bigk4 = 1;
			other.destroy();
			sound_stop_all();
			sound_play("monny");
			sound_play("tele");
			global.uxyz = -1;
			new AR1Dialog()
			{

				@Override
				public void dialog() throws ConverseException, SleepException
				{
					show_message("You have been teleported to the room of doors.");
					sleep(1000);

					{
						transition_kind(0);
						room_goto("portalkeys");
					}
				}
			}.start();
			if(isDisposed())
				return;
		}
		for(Lockboss1 other : getCollisions(Lockboss1.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				other.inv = 30;
				other.life += -global.sharpness;
				if(other.life < 0)
				{
					instance_create(other.x+17,other.y+0,Explodd2.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Doorlockd1 other : getCollisions(Doorlockd1.class))
		{
			x=xprevious+8;
			hspeed=-hspeed;
			if(isDisposed())
				return;
		}
		for(Doorlockd2 other : getCollisions(Doorlockd2.class))
		{
			x=xprevious+8;
			hspeed=-hspeed;
			if(isDisposed())
				return;
		}
		for(Lockboss2 other : getCollisions(Lockboss2.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				other.inv = 30;
				other.life += -global.sharpness;
				if(other.life < 0)
				{
					instance_create(other.x+17,other.y+0,Explodd2.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Lockboss3 other : getCollisions(Lockboss3.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				other.inv = 30;
				other.life += -global.sharpness;
				if(other.life < 0)
				{
					instance_create(other.x+17,other.y+0,Explodd2.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Butondestb3 other : getCollisions(Butondestb3.class))
		{
			if (global.butprs==0)
			{
				other.image_single(1);
				global.butprs = 1;
				sound_play("cloack");
				AR1Dialog.simple_message("Something has happened...");
			}
			if(isDisposed())
				return;
		}
		for(Evilteleport other : getCollisions(Evilteleport.class))
		{
			sound_play("tele");
			global.uxyz = -1;
			new AR1Dialog()
			{

				@Override
				public void dialog() throws ConverseException, SleepException
				{
					show_message("You have been teleported away...");
					sleep(1000);

					{
						transition_kind(0);
						room_goto("bossright1");
					}
				}
			}.start();
			if(isDisposed())
				return;
		}
		for(Tojungtown other : getCollisions(Tojungtown.class))
		{
			global.uxyz = 4;
			goIn(500, "jungltown");
			if(isDisposed())
				return;
		}
		for(Fromjungtw other : getCollisions(Fromjungtw.class))
		{
			global.uxyz = 0;
			goIn(500, "thrwayungle");
			if(isDisposed())
				return;
		}
		for(Tobotomjung other : getCollisions(Tobotomjung.class))
		{
			global.uxyz = 1;
			goIn(500, "thrwayungle");
			if(isDisposed())
				return;
		}
		for(Tokyfromjung other : getCollisions(Tokyfromjung.class))
		{
			global.uxyz = 0;
			goIn(500, "portalkeys");
			if(isDisposed())
				return;
		}
		for(Barexx2 other : getCollisions(Barexx2.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 1;
				goIn(500, "jungltown");
			}
			if(isDisposed())
				return;
		}
		for(Barin2 other : getCollisions(Barin2.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "newbar");
			}
			if(isDisposed())
				return;
		}
		for(Goutainn other : getCollisions(Goutainn.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 2;
				goIn(500, "jungltown");
			}
			if(isDisposed())
				return;
		}
		for(Goininn other : getCollisions(Goininn.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "jungleinn");
			}
			if(isDisposed())
				return;
		}
		for(Gojunuj other : getCollisions(Gojunuj.class))
		{
			global.uxyz = 0;
			goIn(500, "jungnuj");
			if(isDisposed())
				return;
		}
		for(Totwey other : getCollisions(Totwey.class))
		{
			global.uxyz = 2;
			goIn(500, "thrwayungle");
			if(isDisposed())
				return;
		}
		for(Kylier1 other : getCollisions(Kylier1.class))
		{
			global.newkeytak1 = 1;
			other.destroy();
			sound_play("monny");
			sound_play("tele");
			global.uxyz = 1;
			new AR1Dialog()
			{

				@Override
				public void dialog() throws ConverseException, SleepException
				{
					show_message("You have been teleported back outside the cave.");
					sleep(1000);

					{
						transition_kind(0);
						room_goto("jungnuj");
					}
				}
			}.start();
			if(isDisposed())
				return;
		}
		for(Gotosmbs other : getCollisions(Gotosmbs.class))
		{
			if (global.smcavseald==0)
			{
				global.uxyz = 1;
				goIn(500, "lowboss");
			}
			else
			{
				hspeed=-hspeed;
				x=xprevious;
				AR1Dialog.simple_message("The entrance has been closed.");
			}
			if(isDisposed())
				return;
		}
		for(Maspeakw2 other : getCollisions(Maspeakw2.class))
		{
			alarm[3] = 3;
			if (hy==0)
			{
				hy = 1;
				new AR1Dialog()
				{
					final boolean badlyHurt = global.life<global.maxlife/4;
					boolean healed = false;

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.abzolniu>0)
						{
							show_message("You have removed all the robots! The world is grateful.");
							if (global.gsgfhfs<2)
								show_message("Its just that I feel there is something more...");
							else
								show_message("Now your job is done.");
							global.poisoned = 0;
							global.life = global.maxlife;
							sound_play("monny");
						}
						else
						{
							show_message("Hello, "+(global.name)+"!");
							if (show_question("Do you want my advice in your situation?"))
							{
								if (badlyHurt)
								{
									show_message("You are quite badly hurt. I can help you a bit.");
									show_message("You have restored 32 health points.");
									if(!healed)
									{
										sound_play("monny");
										global.life += 32;
										healed = true;
									}
									sleep(500);

								}
								else
								{
									if (global.life<global.maxlife/2)
										show_message("You should heal yourself.");
								}
								if (global.butprs==0)
									show_message("Search the jungle and you will find a button that opens the metal temple left of the town.");
								else
								{
									if (global.mineopen2==0)
									{
										show_message("You can now enter the metal temple.");
										show_message("You will find a new room of doors like where you come from.");
									}
									if (global.blueplac==0 && global.opennew==1)
										show_message("You can now enter the blue caves. Left of them you will find a new town.");
								}
								if (global.newkeytak1==0)
									show_message("You can find a key if you go all to the right and into a cave.");
								if (global.newkeytak2==0)
									show_message("Go to the right side of the jungle and find the house where the medicine animal lives. Speak with him.");
								if (global.newkeytak3==0 && global.newkeytak4==0)
									show_message("There are two keys hidden in the metal temple.");
								if (global.newkeytak3==0 && global.newkeytak4==1)
									show_message("There is one key hidden in the metal temple.");
								if (global.newkeytak3==1 && global.newkeytak4==0)
									show_message("There is one key hidden in the metal temple.");
								if (global.blueplac>0)
									show_message("You can go to the blue caves. There I cannot help you.");
								show_message("I have no more advice for you.");
							}
							else
								show_message("Come back later!");
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Towise other : getCollisions(Towise.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "adviseren2");
			}
			if(isDisposed())
				return;
		}
		for(Fromwise other : getCollisions(Fromwise.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 3;
				goIn(500, "thrwayungle");
			}
			if(isDisposed())
				return;
		}
		for(Medguyd other : getCollisions(Medguyd.class))
		{
			alarm[3] = 3;
			if (hy==0)
			{
				hy = 1;
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						int q = 0;
						if (global.abzolniu>0)
							show_message("You are a hero! The robots are all gone!");
						if (global.poisoned==1)
						{
							q = 1;
							show_message("Oh, you are poisoned!");
							sound_play("monny");
							global.poisoned = 0;
						}
						if (global.life<global.maxlife/1.25)
						{
							q = 1;
							show_message("You are unjured!");
							sound_play("monny");
							global.life = global.maxlife/1.25;
						}
						if (q==0)
							show_message("Come by when you are low on health! I know how to heal.");
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Kylier2 other : getCollisions(Kylier2.class))
		{
			global.newkeytak2 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Tomed other : getCollisions(Tomed.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "medanimal");
			}
			if(isDisposed())
				return;
		}
		for(Frommed other : getCollisions(Frommed.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 2;
				goIn(500, "jungnuj");
			}
			if(isDisposed())
				return;
		}
		for(Metemplis other : getCollisions(Metemplis.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					new AR1Dialog()
					{
						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (global.butprs==1)
							{
								global.uxyz = 0;
								sleep(500);

								{
									transition_kind(0);
									room_goto("jungmetemp");
								}
							}
							else
								show_message("Closed");
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Fromtemp other : getCollisions(Fromtemp.class))
		{
			global.uxyz = 0;
			goIn(500, "jungltown");
			if(isDisposed())
				return;
		}
		for(Bornobatt other : getCollisions(Bornobatt.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{

				new AR1Dialog()
				{
					boolean noisePlayed = false;
					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.batters==1)
						{
							show_message("You insert your batteries.");
							if (global.opennew>0)
							{
								show_message("Biip!");
								sound_play("shootout");
								other.image_speed = 1;
								other.vspeed=8;
								global.batters = 2;
							}
							else
								show_message("Malfunction -Try again later-");
						}
						else
						{
							if(!noisePlayed) 
							{
								sound_play("nouse");
								noisePlayed = true;
							}
							show_message("It is not operative.");
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Batteries other : getCollisions(Batteries.class))
		{
			global.batters = 1;
			other.destroy();
			sound_play("monny");
			AR1Dialog.simple_message("You have found some batteries.");
			if(isDisposed())
				return;
		}
		for(Girlinhous other : getCollisions(Girlinhous.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
				alarm[3] = 3;
				if (hy==0)
				{
					hy = 1;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (global.abzolniu>0)
								show_message("You are my hero! You're welcome to spend the night here any time you want.");
							else
							{
								if (global.spoken==0)
								{
									show_message("Girl: Hello. What brings you here?");
									show_message("You: I am on a quest to get rid of these robots that shows up everywhere.");
									show_message("Girl: Okay... I dont think I can help you with that, but its nice to meet you anyway. Whats your name?");
									show_message("You: My name is "+(global.name)+".");
									global.spoken = 1;
								}
								else
								{
									show_message("You are kind of cute, but now is not the time.");
								}
							}
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Togirl other : getCollisions(Togirl.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "civshous1");
			}
			if(isDisposed())
				return;
		}
		for(Fromgirl other : getCollisions(Fromgirl.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 3;
				goIn(500, "jungltown");
			}
			if(isDisposed())
				return;
		}
		for(Kylier3 other : getCollisions(Kylier3.class))
		{
			global.newkeytak3 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Kylier4 other : getCollisions(Kylier4.class))
		{
			global.newkeytak4 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Savemee other : getCollisions(Savemee.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							show_message("I am lost! Please help me out of here!");
							show_message("Bring me to the village!");
							other.destroy();
							global.savedud = 1;
							hy = 1;
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Hitsavedud other : getCollisions(Hitsavedud.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.savedud<2)
							show_message("Closed...");
						else
						{
							global.uxyz = -1;
							sleep(500);

							{
								transition_kind(0);
								room_goto("civshous2");
							}
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Outtacivtwo other : getCollisions(Outtacivtwo.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 2;
				goIn(500, "town");
			}
			if(isDisposed())
				return;
		}
		for(Guyousaved other : getCollisions(Guyousaved.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					AR1Dialog.simple_message("You saved me. and I will always be grateful.");
				}
			if(isDisposed())
				return;
		}
		for(Teletown other : getCollisions(Teletown.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					alarm[3] = 30;
					hy = 1;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							show_message("The portal leads to town.");
							if (show_question("Enter?"))
							{
								global.uxyz = 5;
								{
									transition_kind(0);
									room_goto("jungltown");
								}
							}
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Newgate1 other : getCollisions(Newgate1.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.bigknew1==1)
							show_message("You have finished your work there.");
						else
						{
							if (global.newkeytak1==1)
							{
								if (hy==0)
								{
									alarm[3] = 30;
									show_message("The portal leads to a strange place.");
									if (show_question("Enter?"))
									{
										hy = 1;
										global.uxyz = -1;
										{
											transition_kind(0);
											room_goto("adplace");
										}
									}
									else
										hy = 1;
								}
							}
							else
								show_message("You need another key...");
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Newgate2 other : getCollisions(Newgate2.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.bigknew2==1)
							show_message("You have finished your work there.");
						else
						{
							if (global.newkeytak2==1)
							{
								if (hy==0)
								{
									alarm[3] = 30;
									show_message("The portal leads to a dangerous place.");
									if (show_question("Enter?"))
									{
										global.uxyz = -1;
										hy = 1;
										{
											transition_kind(0);
											room_goto("boss3holl");
										}
									}
									else
										hy = 1;
								}
							}
							else
								show_message("You need another key...");
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Newgate3 other : getCollisions(Newgate3.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.bigknew3==1)
							show_message("You have finished your work there.");
						else
						{
							if (global.newkeytak3==1)
							{
								if (hy==0)
								{
									alarm[3] = 30;
									show_message("The portal leads to an exploding place.");
									if (show_question("Enter?"))
									{
										global.uxyz = -1;
										hy = 1;
										{
											transition_kind(0);
											room_goto("explodings");
										}
									}else
										hy = 1;
								}
							}
							else
								show_message("You need another key...");
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Newgate4 other : getCollisions(Newgate4.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.newkeytak4==1)
						{
							if (hy==0)
							{
								alarm[3] = 30;
								show_message("The portal leads to the stairs to the stormy mountains.");
								if (show_question("Enter?"))
								{
									global.uxyz = -1;
									hy = 1;
									{
										transition_kind(0);
										room_goto("uptomounts");
									}
								}
								else
									hy = 1;
							}
						}
						else
							show_message("You need another key...");
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Hollbig1 other : getCollisions(Hollbig1.class))
		{
			global.bigknew1 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Hollbig2 other : getCollisions(Hollbig2.class))
		{
			global.bigknew2 = 1;
			other.destroy();
			sound_stop_all();
			sound_play("monny");
			sound_play("tele");
			global.uxyz = -1;
			new AR1Dialog()
			{

				@Override
				public void dialog() throws ConverseException, SleepException
				{
					show_message("You have been teleported to the room of doors.");
					sleep(1000);

					{
						transition_kind(0);
						room_goto("portals2");
					}
				}
			}.start();
			if(isDisposed())
				return;
		}
		for(Hollbig3 other : getCollisions(Hollbig3.class))
		{
			global.bigknew3 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Tonewplac other : getCollisions(Tonewplac.class))
		{
			global.uxyz = 0;
			goIn(500, "blueplace");
			if(isDisposed())
				return;
		}
		for(Toports2 other : getCollisions(Toports2.class))
		{
			global.uxyz = -1;
			goIn(500, "portals2");
			if(isDisposed())
				return;
		}
		for(Fromports2 other : getCollisions(Fromports2.class))
		{
			global.uxyz = 3;
			goIn(500, "jungmetemp");
			if(isDisposed())
				return;
		}
		for(Object357 other : getCollisions(Object357.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (global.robopartsouv==1)
				{
					global.robopartsouv = 2;
					other.sprite = Sprite.get("smashdno");
					image_xscale=1;
					image_yscale=1;
					instance_create(other.x+32,other.y+-32,Object516.class);
				}
			if(isDisposed())
				return;
		}
		for(Goingdown other : getCollisions(Goingdown.class))
		{
			global.uxyz = 0;
			goIn(500, "downintemp");
			if(isDisposed())
				return;
		}
		for(Teletopors2 other : getCollisions(Teletopors2.class))
		{
			sound_play("tele");
			global.uxyz = -1;
			new AR1Dialog()
			{

				@Override
				public void dialog() throws ConverseException, SleepException
				{
					show_message("You have been teleported to the room of doors.");
					sleep(1000);

					{
						transition_kind(0);
						room_goto("portals2");
					}
				}
			}.start();
			if(isDisposed())
				return;
		}
		for(Gotofall other : getCollisions(Gotofall.class))
		{
			global.uxyz = -1;
			goIn(500, "falltojung");
			if(isDisposed())
				return;
		}
		for(Gofromfall other : getCollisions(Gofromfall.class))
		{
			global.uxyz = 1;
			goIn(500, "theminein");
			if(isDisposed())
				return;
		}
		for(Gojungfall other : getCollisions(Gojungfall.class))
		{
			global.uxyz = 3;
			goIn(500, "jungnuj");
			if(isDisposed())
				return;
		}
		for(Gobluespec other : getCollisions(Gobluespec.class))
		{
			global.uxyz = 1;
			goIn(500, "blueplace");
			if(isDisposed())
				return;
		}
		for(Waybluspec other : getCollisions(Waybluspec.class))
		{
			global.uxyz = 1;
			goIn(500, "downintemp");
			if(isDisposed())
				return;
		}
		for(Backfrblu other : getCollisions(Backfrblu.class))
		{
			global.uxyz = 1;
			goIn(500, "portals2");
			if(isDisposed())
				return;
		}
		for(Boss3ye other : getCollisions(Boss3ye.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				other.inv = 30;
				other.life += -global.sharpness;
				if(other.life < 0)
				{
					instance_create(other.x+17,other.y+0,Explodd3.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Boss3killst other : getCollisions(Boss3killst.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				other.inv = 30;
				other.life += -global.sharpness;
				if(other.life < 0)
				{
					instance_create(other.x+17,other.y+0,Explodd3.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Dangexp other : getCollisions(Dangexp.class))
		{
			if (inv<1)
			{
				global.life += -other.damage;
				sound_play("ough");
				inv = 45;
			}
			if(isDisposed())
				return;
		}
		for(Fakerhole other : getCollisions(Fakerhole.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				other.inv = 30;
				other.life += -global.sharpness;
				if(other.life < 0)
				{
					instance_create(other.x+17,other.y+0,Explodd2.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Goblutown other : getCollisions(Goblutown.class))
		{
			global.uxyz = -1;
			goIn(500, "cavetown");
			if(isDisposed())
				return;
		}
		for(Fromblutown other : getCollisions(Fromblutown.class))
		{
			global.uxyz = 2;
			goIn(500, "blueplace");
			if(isDisposed())
				return;
		}
		for(Toniuinn other : getCollisions(Toniuinn.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "bluinn");
			}
			if(isDisposed())
				return;
		}
		for(Frniuinn other : getCollisions(Frniuinn.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 1;
				goIn(500, "cavetown");
			}
			if(isDisposed())
				return;
		}
		for(Toniushop other : getCollisions(Toniushop.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "blubar");
			}
			if(isDisposed())
				return;
		}
		for(Fromniushop other : getCollisions(Fromniushop.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 3;
				goIn(500, "cavetown");
			}
			if(isDisposed())
				return;
		}
		for(Object389 other : getCollisions(Object389.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (global.abzolniu>0)
								show_message("You have destroyed all of the robots I hear! The machinery is running smoothly like never before!");
							else
							{
								if (global.spooken2==0)
								{
									show_message("Other: Hello, who are you?");
									show_message("You: My name is "+(global.name)+". I am on a quest and I am trying to get rid of all these robots that shows up erverywhere.");
									show_message("Other: I am watching this machinery and making sure it works. It may look like enemy machinery, but its really keeping the whole town going.");
									global.spooken2 = 1;
								}
								else
								{
									if (global.thekicard<2)
									{
										if (global.cha==2)
											show_message("I cant help you now. Maybe after your quest...");
										if (global.cha==0 || global.cha==1)
											show_message("Dont destroy anything please...");
									}
									else
										show_message("You managed to open the door! Nice.");
								}
							}
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Tomachin other : getCollisions(Tomachin.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						sleep(500);

						if (global.reactdeadevil==1)
						{
							transition_kind(0);
							room_goto("evilpowerhzz");
						}
						if (global.reactdeadevil==0 || global.reactdeadevil>2)
						{
							transition_kind(0);
							room_goto("powerhouse");
						}
						if (global.reactdeadevil==2)
							show_message("The macines are getting rebuilt.");
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Fromachin other : getCollisions(Fromachin.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 2;
				goIn(500, "cavetown");
			}
			if(isDisposed())
				return;
		}
		for(Falltocvtwn other : getCollisions(Falltocvtwn.class))
		{
			global.uxyz = 4;
			goIn(500, "cavetown");
			if(isDisposed())
				return;
		}
		for(Fromstarholl other : getCollisions(Fromstarholl.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 2;
				goIn(500, "downintemp");
			}
			if(isDisposed())
				return;
		}
		for(Tomotainstrm other : getCollisions(Tomotainstrm.class))
		{
			global.uxyz = 0;
			goIn(500, "mountainstrm");
			if(isDisposed())
				return;
		}
		for(Tosatrholl other : getCollisions(Tosatrholl.class))
		{
			global.uxyz = 2;
			goIn(500, "uptomounts");
			if(isDisposed())
				return;
		}
		for(Doorsolid other : getCollisions(Doorsolid.class))
		{
			if (global.thekicard<2)
			{
				alarm[3] = 3;
				if (still==0 && keyboard_check_pressed(VK.UP))
					if (hy==0)
					{
						hy = 1;
						new AR1Dialog()
						{

							@Override
							public void dialog() throws ConverseException, SleepException
							{
								show_message("Guard: That door has been closed a very long time. I dont even know whats in there. It is said to be unbreakable.");
								if (global.thekicard==1)
								{
									show_message("You insert your keycard.");
									instance(Opener400.class).sprite = Sprite.get("accepyf");
									other.image_speed = 0.5;
									global.thekicard = 2;
								}
							}
						}.start();
					}
			}
			if(isDisposed())
				return;
		}
		for(Kycrd other : getCollisions(Kycrd.class))
		{
			global.thekicard = 1;
			other.destroy();
			sound_play("monny");
			AR1Dialog.simple_message("You have found a keycard.");
			if(isDisposed())
				return;
		}
		for(Object402 other : getCollisions(Object402.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					global.uxyz = -1;
					goIn(500, "enginports3");
				}
			if(isDisposed())
				return;
		}
		for(Civoinmoun other : getCollisions(Civoinmoun.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (global.spooken5==0)
							{
								show_message("I am the assistant of the watcher of the mountain. My task is to stay here and watch the weather.");
							}
							else
							{
								show_message("I can go home? Good. Thanks for telling me. Here is 40 valuables.");
								global.reactdeadevil = 1;
								sound_play("monny");
								global.spooken5 = 2;
								global.score += 40;
								instance_create(other.x+0,other.y+0,Civimghom.class);
								other.destroy();
							}
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Dawitch other : getCollisions(Dawitch.class))
		{
			alarm[3] = 4;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					new AR1Dialog()
					{
						final int inngrodd1 = global.inngrodd1;
						final int inngrodd2 = global.inngrodd2;
						final int inngrodd3 = global.inngrodd3;
						final int inngrodd4 = global.inngrodd4;
						final int inngrodd5 = global.inngrodd5;
						final int inngrodd6 = global.inngrodd6;

						final boolean injured = global.life<global.maxlife/1.25;
						boolean healed = false;
						
						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (global.inngrodd1<3)
							{
								hy = 1;

								if (injured)
								{
									show_message("Oh, you are injured. Take some healing brew.");
									if(!healed)
									{
										sound_play("monny");
										global.life = global.maxlife/1.25;
										healed = true;
									}
									sleep(500);

								}
								
								show_message("I am making some soup. I need some ingredients.");
								if (inngrodd1<2)
									show_message("I need the handle of a broken key");
								if (inngrodd2<2)
									show_message("I need an orange mushroom");
								if (inngrodd3<2)
									show_message("I need a rock with a red layer");
								if (inngrodd4<2)
									show_message("I need a broken glass");
								if (inngrodd5<2)
									show_message("I need a leaf from a blue bush");
								if (inngrodd6<2)
									show_message("I need a red ball");
								show_message("If you can get that for me you might get a reward.");
								if (inngrodd1==1)
								{
									show_message("Oh, you have the handle of a broken key!");
									if(global.inngrodd1==1)
										sound_play("lavabobl");
									global.inngrodd1 = 2;
								}
								if (inngrodd2==1)
								{
									show_message("Oh, you have an orange mushroom I need!");
									if(global.inngrodd2==1)
										sound_play("lavabobl");
									global.inngrodd2 = 2;
								}
								if (inngrodd3==1)
								{
									show_message("Oh, you have got a rock with a red layer for me!");
									if(global.inngrodd3==1)
										sound_play("lavabobl");
									global.inngrodd3 = 2;
								}
								if (inngrodd4==1)
								{
									show_message("Oh, you have found a broken glass!");
									if(global.inngrodd4==1)
										sound_play("lavabobl");
									global.inngrodd4 = 2;
								}
								if (inngrodd5==1)
								{
									show_message("You have got a leaf from a blue bush!");
									if(global.inngrodd5==1)
										sound_play("lavabobl");
									global.inngrodd5 = 2;
								}
								if (inngrodd6==1)
								{
									show_message("You got a red ball for me!");
									if(global.inngrodd6==1)
										sound_play("lavabobl");
									global.inngrodd6 = 2;
								}
								if (global.inngrodd1==2)
									if (global.inngrodd2==2)
										if (global.inngrodd3==2)
											if (global.inngrodd4==2)
												if (global.inngrodd5==2)
													if (global.inngrodd6==2)
													{
														show_message("Now I have got all the ingredients I need to make soup!");
														show_message("Lets see what happens...");
														global.inngrodd1 = 3;
														still = 1;
														instance(Bigryte.class).intenza = true;
														other.alarm[1] = 60;
													}
							}
							else
							{
								show_message("Thank you for helping me with my soup.");
								if (global.abzolniu>0)
									show_message("I see the robots are all gone. Did you fix that?");
							}
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Towitch other : getCollisions(Towitch.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "witchous");
			}
			if(isDisposed())
				return;
		}
		for(Fromwitch other : getCollisions(Fromwitch.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 2;
				goIn(500, "themountain");
			}
			if(isDisposed())
				return;
		}
		for(Tonobody other : getCollisions(Tonobody.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (instance_number(Civimghom.class)==0)
						{
							global.uxyz = -1;
							sleep(500);

							{
								transition_kind(0);
								room_goto("nobodyhous");
							}
						}
						else
							show_message("Please wait until the assistant has arrived.");
					}
				}.start();

			}
			if(isDisposed())
				return;
		}
		for(Fromnobody other : getCollisions(Fromnobody.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 2;
				goIn(500, "mountainstrm");
			}
			if(isDisposed())
				return;
		}
		for(Elvatblu other : getCollisions(Elvatblu.class))
		{
			if (still==1)
			{
				double hiu = other.x-other.xprevios;
				//double viu = other.y-other.yprevios; ?
				vspeed=-gravity-friction+2;
				{
					x=x+hiu;
					y=other.y+2;
				}
			}
			if(isDisposed())
				return;
		}
		for(Elvtomoiun other : getCollisions(Elvtomoiun.class))
		{
			global.uxyz = 4;
			goIn(500, "mountainstrm");
			if(isDisposed())
				return;
		}
		for(Muths other : getCollisions(Muths.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (global.abzolniu>0)
								show_message("Your quest was a success I see! The robots are gone!");
							else
							{
								if (global.spoken3==0)
								{
									show_message("Mother: Hello. What brings you here?");
									show_message("You: I am working on getting rid of these robots that shows up everywhere.");
									show_message("Mother: I dont think we can help you much but its nice to meet you. Whats your name?");
									show_message("You: My name is "+(global.name)+".");
									show_message("Father: Before these bad things began to happen we could travel between the towns. We could also travel in the mountain. It is impossible now, because of the incredible wind up there, and, of course, the robots. There is an elevator just right of here that brings you to the mountain, but it isnt very pleasant up there.");
									show_message("Mother: On the top of the mountain there lives a wise old man. Maybe he can help you.");
									global.spoken3 = 1;
								}
								else
								{
									show_message("Come back and visit us after your job and maybe we can be friends.");
								}
							}
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Tofam other : getCollisions(Tofam.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "civshouse3");
			}
			if(isDisposed())
				return;
		}
		for(Fromfam other : getCollisions(Fromfam.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP) && !place_meeting(x, y, Ingnr6.class))
			{
				global.uxyz = 6;
				goIn(500, "cavetown");
			}
			if(isDisposed())
				return;
		}
		for(Object440 other : getCollisions(Object440.class))
		{
			global.bigknewblu1 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Object441 other : getCollisions(Object441.class))
		{
			global.bigknewblu2 = 1;
			other.destroy();
			sound_play("monny");
			new AR1Dialog()
			{
				boolean playedNoise = false;
				@Override
				public void dialog() throws ConverseException, SleepException
				{
					sleep(300);

					if(!playedNoise) {
						sound_play("tele");
						playedNoise = true;
					}
					global.uxyz = -1;
					show_message("You have been teleported to the room of doors.");
					sleep(1000);

					{
						transition_kind(0);
						room_goto("enginports3");
					}
				}
			}.start();
			if(isDisposed())
				return;
		}
		for(Object442 other : getCollisions(Object442.class))
		{
			global.bigknewblu3 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Fromkarte other : getCollisions(Fromkarte.class))
		{
			global.uxyz = 1;
			goIn(500, "powerhouse");
			if(isDisposed())
				return;
		}
		for(Teletopors3 other : getCollisions(Teletopors3.class))
		{
			sound_play("tele");
			global.uxyz = -1;
			new AR1Dialog()
			{

				@Override
				public void dialog() throws ConverseException, SleepException
				{
					show_message("You have been teleported to the room of doors.");
					sleep(1000);

					{
						transition_kind(0);
						room_goto("enginports3");
					}
				}
			}.start();
			if(isDisposed())
				return;
		}
		for(Por3gat1 other : getCollisions(Por3gat1.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.bigknewblu1==1)
							show_message("You have finished your work there.");
						else
						{
							if (global.blunuky1==1)
							{
								if (hy==0)
								{
									alarm[3] = 30;
									show_message("The portal leads to a vertical place.");
									if (show_question("Enter?"))
									{
										global.uxyz = -1;
										hy = 1;
										{
											transition_kind(0);
											room_goto("fallgetkard");
										}
									}
									else
										hy = 1;
								}
							}
							else
								show_message("You need another key...");
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Por3gat2 other : getCollisions(Por3gat2.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{
					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.bigknewblu2==1)
							show_message("You have finished your work there.");
						else
						{
							if (global.blunuky2==1)
							{
								if (hy==0)
								{
									alarm[3] = 30;
									show_message("The portal leads to the jungle...");
									if (show_question("Enter?"))
									{
										global.uxyz = -1;
										hy = 1;
										{
											transition_kind(0);
											room_goto("fakejung");
										}
									}
									else
										hy = 1;
								}
							}
							else
								show_message("You need another key...");
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Por3gat3 other : getCollisions(Por3gat3.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.bigknewblu3==1)
							show_message("You have finished your work there.");
						else
						{
							if (global.blunuky3==1)
							{
								if (hy==0)
								{
									alarm[3] = 30;
									show_message("The portal leads to someplace close.");
									if (show_question("Enter?"))
									{
										global.uxyz = 3;
										hy = 1;
										{
											transition_kind(0);
											room_goto("blueplace");
										}
									}
									else
										hy = 1;
								}
							}
							else
								show_message("You need another key...");
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Blauki1 other : getCollisions(Blauki1.class))
		{
			global.blunuky1 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Blauki2 other : getCollisions(Blauki2.class))
		{
			global.blunuky2 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Blauki3 other : getCollisions(Blauki3.class))
		{
			global.blunuky3 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Ondatophus other : getCollisions(Ondatophus.class))
		{
			if (global.spooken5>2)
				global.spooken5 = 0;
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					new AR1Dialog()
					{
						final boolean poisoned = global.poisoned==1;
						final boolean injured = global.life<global.maxlife/1.25;
						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (global.abzolniu>0)
							{
								show_message("Your mission is complete and you have no need for my advice anymore now.");
								if (global.gsgfhfs<2)
									show_message("But I feel you are not all finished yet...");
								else
									show_message("Your job is done.");
								if (global.spooken5<1)
								{
									show_message("If you see my assistant tell him to go home.");
									global.spooken5 = 1;
								}
							}
							else
							{
								if (global.spooken5==0)
								{
									show_message("Watcher: I am the watcher of the mountain. I have lived here a very long time and never have I seen such a storm.");
									show_message("You: My name is "+(global.name)+" and I am trying to find out what has happened to the world.");
									show_message("Watcher: I can be of some help. I can heal you if you need it and I can give you some advice. My assistant is watching somewhere in the mountains. if you see him you can tell him he can go home.");
									show_message("Watcher: If you want to get down from the mountain faster, you can travel through this door. It gets you to my assistants house further down in the mountain.");
									global.spooken5 = 1;
								}
								else
								{
									int q = 0;
									if (poisoned)
									{
										q = 1;
										show_message("You are poisoned!");
										if(global.poisoned==1)
										{
											sound_play("monny");
											global.poisoned = 0;
										}
									}
									if (injured)
									{
										q = 1;
										show_message("You are injured!");
										if(global.life<global.maxlife/1.25)
										{
											sound_play("monny");
											global.life = global.maxlife/1.25;
										}
									}
									if (q==0)
										show_message("Come by when you are low on health! I know how to heal.");

									if (global.thekicard==0)
									{
										show_message("Right of my assistants watching post you will find a keycard that will open the sealed door in the engine room of the town.");
									}
									if (global.opennewye3==0)
										show_message("Behind the engine room in the town you will find a room where you must gather the pieces of a big keycard.");
									//qk
									if (global.blunuky1==0 && global.blunuky2==0 && global.blunuky3==0)
										show_message("You must find the three blue keys to be able to get the big keycard.");
									if (global.blunuky1==1 && global.blunuky2==0 && global.blunuky3==0)
										show_message("You must find the two remaining blue keys to be able to get the big keycard.");
									if (global.blunuky1==0 && global.blunuky2==1 && global.blunuky3==0)
										show_message("You must find the two remaining blue keys to be able to get the big keycard.");
									if (global.blunuky1==0 && global.blunuky2==0 && global.blunuky3==1)
										show_message("You must find the two remaining blue keys to be able to get the big keycard.");
									if (global.blunuky1==0 && global.blunuky2==1 && global.blunuky3==1)
										show_message("You must find one more blue key to be able to get the big keycard.");
									if (global.blunuky1==1 && global.blunuky2==1 && global.blunuky3==0)
										show_message("You must find one more blue key to be able to get the big keycard.");
									if (global.blunuky1==1 && global.blunuky2==0 && global.blunuky3==1)
										show_message("You must find one more blue key to be able to get the big keycard.");
									//qk
									if (global.blunuky1==0)
										show_message("The first key is somewhere in the cave right of town.");
									if (global.blunuky2==0)
										show_message("The second key is in the town.");
									if (global.blunuky3==0)
										show_message("The third key is quite low in the mountain.");
									if (global.opennewye4==0)
									{
										show_message("Somewhere in the stormy mountains there goes a cave downwards.");
										show_message("There you will find another key that has to be gathered to complete your mission.");
									}
								}
							}
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Mounhous other : getCollisions(Mounhous.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							show_message("Travel through here to visit my boss.");
							if (global.abzolniu>0)
								show_message("He will be happy to see you. It is safe in the mountains and the horrible storm is gone!");
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Nobodygate other : getCollisions(Nobodygate.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.nobo==1)
						{
							global.uxyz = 1;
							sleep(500);

							{
								transition_kind(0);
								room_goto("nobody2");
							}
						}
						else
							show_message("Closed...");
					}
				}.start();

			}
			if(isDisposed())
				return;
		}
		for(Backdownn other : getCollisions(Backdownn.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 1;
				global.nobo = 1;
				goIn(500, "nobodyhous");
			}
			if(isDisposed())
				return;
		}
		for(Fromtoppx other : getCollisions(Fromtoppx.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 1;
				goIn(500, "topofmounte");
			}
			if(isDisposed())
				return;
		}
		for(Totoppx other : getCollisions(Totoppx.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "nobody2");
			}
			if(isDisposed())
				return;
		}
		for(Todemtp other : getCollisions(Todemtp.class))
		{
			global.uxyz = -1;
			goIn(500, "topofmounte");
			if(isDisposed())
				return;
		}
		for(Fromdemtp other : getCollisions(Fromdemtp.class))
		{
			global.uxyz = 3;
			goIn(500, "mountainstrm");
			if(isDisposed())
				return;
		}
		for(Togates4 other : getCollisions(Togates4.class))
		{
			global.uxyz = -1;
			goIn(500, "portaler4");
			if(isDisposed())
				return;
		}
		for(Fromgates4 other : getCollisions(Fromgates4.class))
		{
			global.uxyz = 1;
			goIn(500, "mountainstrm");
			if(isDisposed())
				return;
		}
		for(Tonew1 other : getCollisions(Tonew1.class))
		{
			global.uxyz = 0;
			goIn(500, "hiddenplace");
			if(isDisposed())
				return;
		}
		for(Tonew2 other : getCollisions(Tonew2.class))
		{
			global.uxyz = 1;
			goIn(500, "hiddenplace");
			if(isDisposed())
				return;
		}
		for(Fromnew1 other : getCollisions(Fromnew1.class))
		{
			global.uxyz = 7;
			goIn(500, "cavetown");
			if(isDisposed())
				return;
		}
		for(Fromnew2 other : getCollisions(Fromnew2.class))
		{
			global.uxyz = 5;
			goIn(500, "mountainstrm");
			if(isDisposed())
				return;
		}
		for(Object469 other : getCollisions(Object469.class))
		{
			global.oddkey1 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Object470 other : getCollisions(Object470.class))
		{
			global.oddkey2 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Object471 other : getCollisions(Object471.class))
		{
			global.oddkey3 = 1;
			other.destroy();
			sound_play("monny");
			if(isDisposed())
				return;
		}
		for(Tocavtel other : getCollisions(Tocavtel.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					alarm[3] = 30;
					hy = 1;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							show_message("The portal leads to town.");
							if (show_question("Enter?"))
							{
								global.uxyz = 5;
								{
									transition_kind(0);
									room_goto("cavetown");
								}
							}
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Teletopors4 other : getCollisions(Teletopors4.class))
		{
			sound_play("tele");
			global.uxyz = -1;
			new AR1Dialog()
			{

				@Override
				public void dialog() throws ConverseException, SleepException
				{
					show_message("You have been teleported to the room of doors.");
					sleep(1000);

					{
						transition_kind(0);
						room_goto("portaler4");
					}
				}
			}.start();
			if(isDisposed())
				return;
		}
		for(Telyfn1 other : getCollisions(Telyfn1.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.oddkey1==1)
							show_message("You have finished your work there.");
						else
						{
							if (hy==0)
							{
								alarm[3] = 30;
								show_message("The portal leads to a labyrinth-like place.");
								if (show_question("Enter?"))
								{
									global.uxyz = -1;
									hy = 1;
									{
										transition_kind(0);
										room_goto("vanligstygg");
									}
								}
								else
									hy = 1;
							}
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Telyfn2 other : getCollisions(Telyfn2.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.oddkey2==1)
							show_message("You have finished your work there.");
						else
						{
							if (hy==0)
							{
								alarm[3] = 30;
								show_message("The portal leads to a place with lots of evil doors.");
								if (show_question("Enter?"))
								{
									global.uxyz = -1;
									hy = 1;
									{
										transition_kind(0);
										room_goto("doorshootn");
									}
								}
								else
									hy = 1;
							}
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Telyfn3 other : getCollisions(Telyfn3.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.oddkey3==1)
							show_message("You have finished your work there.");
						else
						{
							if (hy==0)
							{
								alarm[3] = 30;
								show_message("The portal leads to an elevator.");
								if (show_question("Enter?"))
								{
									global.uxyz = -1;
									hy = 1;
									{
										transition_kind(0);
										room_goto("upyoky");
									}
								}
								else
									hy = 1;
							}
						}
					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Enemy56 other : getCollisions(Enemy56.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				other.inv = 30;
				other.life += -global.sharpness;
				if(other.life < 0)
				{
					instance_create(other.x+17,other.y+0,Explodd2.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Elvabosd other : getCollisions(Elvabosd.class))
		{
			vspeed=-gravity-friction+2;
			y=other.y+1;
			if(isDisposed())
				return;
		}
		for(Object482 other : getCollisions(Object482.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.abzolniu>0)
							show_message("Your job is complete and we can live our lives again.");
						else
						{
							show_message("Welcome to our town.");
							show_message("I see you have reopened the path between this place and the cave town.");
							show_message("Until now this place has not been much affected by the evil.");
						}
					}
				}.start();

			}
			if(isDisposed())
				return;
		}
		for(Object483 other : getCollisions(Object483.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.abzolniu>0)
							show_message("You have crashed all those robots. Good job!");
						else
						{
							show_message("In the door to the left in this town there is what we think is a weapon that can defeat the great evil that is everywhere.");
							show_message("But we have not been able to get to it because you need 4 big keys or something...");
						}
					}
				}.start();

			}
			if(isDisposed())
				return;
		}
		for(Behbigh3 other : getCollisions(Behbigh3.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (instance(Bigddorz.class).oogh)
				{
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (global.abzolniu>0)
								show_message("Your mission there is complete.");
							else
							{
								if (show_question("Enter?"))
								{
									sleep(500);
									global.abzolniu = 1;
									global.uxyz = -1;

									{
										transition_kind(0);
										room_goto("finalboss");
									}
								}
							}
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Togitz other : getCollisions(Togitz.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "finaldoor5");
			}
			if(isDisposed())
				return;
		}
		for(Fromgitz other : getCollisions(Fromgitz.class))
		{
			global.uxyz = 2;
			goIn(500, "hiddenplace");
			if(isDisposed())
				return;
		}
		for(Tofam2 other : getCollisions(Tofam2.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "cinivwen1");
			}
			if(isDisposed())
				return;
		}
		for(Fromfam2 other : getCollisions(Fromfam2.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 3;
				goIn(500, "hiddenplace");
			}
			if(isDisposed())
				return;
		}
		for(Fromniucix other : getCollisions(Fromniucix.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 4;
				goIn(500, "hiddenplace");
			}
			if(isDisposed())
				return;
		}
		for(Object497 other : getCollisions(Object497.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (global.abzolniu>0)
							{
								if (global.gsgfhfs<2)
									show_message("You have used the weapon. Good job, but I have a feeling you are not finished yet...");
								else
									show_message("You have defeated the mad evil animal. Good.");
							}
							else
							{
								show_message("You are the one with the powers to defeat evil.");
								if (global.opennewye4>0 && global.opennewye3>0)
									show_message("Prepare yourself for anything and go to the cave left of here.");
								else
								{
									if (global.opennewye4>0)
										show_message("Get the remaining big key and return. It is behind the engine room. You need a keycard o get in. If you dont have it, it is in the mountains.");
									else
										show_message("Get the remaining big key and return. It is low in the storm mountains.");
								}
							}
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Toniucix other : getCollisions(Toniucix.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "guyshous");
			}
			if(isDisposed())
				return;
		}
		for(Object499 other : getCollisions(Object499.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				other.inv = 30;
				other.life += -global.sharpness;
				if(other.life < 0)
				{
					instance_create(other.x+17,other.y+0,Explodd2.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Object501 other : getCollisions(Object501.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				other.inv = 30;
				other.life += -global.sharpness;
				if(other.life < 0)
				{
					instance_create(other.x+17,other.y+0,Explodd3.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Object504 other : getCollisions(Object504.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
				other.destroy();
			if(isDisposed())
				return;
		}
		for(Guyusavout other : getCollisions(Guyusavout.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (global.guyran==0)
								show_message("You have saved the world!");
							else
							{
								show_message("You and that guy showed up out of nowhere, then he said something about the destruction of the world and he ran...");
							}
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Barth3out other : getCollisions(Barth3out.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					AR1Dialog.simple_message("You must be the one who removed the robots! Now we can travel in the desert again!");
				}
			if(isDisposed())
				return;
		}
		for(Object508 other : getCollisions(Object508.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (global.blackmushz<3)
							{
								show_message("You must be the one that have defeated the robots. Everybody is talking about you. I like watching the mushrooms.");
								show_message("Do you know where I can find a black mushroom?");
								show_message("If you see one please let me have it.");
								if (global.blackmushz==0)
									global.blackmushz = 1;
								if (global.blackmushz>1)
								{
									show_message("Oh you have one! I can give you this weird key in return.");
									show_message("I dont know what it is for, but I have heard you have been dealing a lot with keys. Maybe you can use it.");
									instance_create(x+0,y+-8,Object513.class);
									global.blackmushz = 3;
									still = 1;
								}
							}
							else
								show_message("Thank you for helping me find the black mushroom. I hope you can use the key.");
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Sleewhgrl other : getCollisions(Sleewhgrl.class))
		{
			if (global.abzolniu>0)
				//if (global.cha==0 || global.cha==1)
				{
					if (still==0 && keyboard_check_pressed(VK.UP))
						alarm[3] = 3;
						if (hy==0 && still==0)
						{
							hy = 1;
							new AR1Dialog()
							{

								@Override
								public void dialog() throws ConverseException, SleepException
								{
									if (show_question("Do you want to sleep here?"))
									{
										Girlinhous g = instance(Girlinhous.class);
										if(g != null)
										{
											instance_create(g.x+0,g.y+0,Object511.class);
											g.destroy();
										}
										x=other.x+(global.cha==2?16:53);
										y=other.y+41;
										vspeed=0;
										hspeed=0;
										gravity=0;
										gravity_direction=0;
										still = 1;
										alarm[5] = 220;
										other.a = 1;
						                if(global.cha == 0)
						                	sprite = Sprite.get("yliel");
						                else if(global.cha == 1)
						                	sprite = Sprite.get("kliel");
						                else
						                	sprite = Sprite.get("flier");
										image_xscale=1;
										image_yscale=1;
									}
								}
							}.start();
						}
				}
			if(isDisposed())
				return;
		}
		for(Theblackguy other : getCollisions(Theblackguy.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (global.robopartsouv<3)
							{
								show_message("I am a tourist here and its very nice here. A little too nice maybe...");
								show_message("I wanted to get a souvenir to go home with. I want a piece of a robot or something, but its all cleaned up.");
								show_message("If you find some part of a robot I would like to have it.");
								if (global.robopartsouv==0)
									global.robopartsouv = 1;
								if (global.robopartsouv>1)
								{
									show_message("Oh you have a piece! I can give you this strange key in return.");
									show_message("I dont know what it is for, but maybe you can use it. I hear there are many things you need keys for here.");
									instance_create(x+0,y+-8,Object515.class);
									global.robopartsouv = 3;
									still = 1;
								}
							}
							else
								show_message("Now I have a nice souvenir to go home with.");
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Object517 other : getCollisions(Object517.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (global.nwhathevva<3)
							{
								show_message("Hello. I like being in these caves, but recently it was occupied by evil robots.");
								show_message("You must be the one that defeated them! Cool! Can you help me with something?");
								show_message("Can you give me a shovel? I want to dig after something.");
								if (global.nwhathevva==0)
									global.nwhathevva = 1;
								if (global.nwhathevva>1)
								{
									show_message("Nice! I can give you this broken key in return.");
									show_message("It looks like its broken, but I think it is supposed to be that way.");
									instance_create(x+0,y+-8,Object519.class);
									global.nwhathevva = 3;
									still = 1;
								}
							}
						}
					}.start();
				}
			if(isDisposed())
				return;
		}
		for(Object520 other : getCollisions(Object520.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					AR1Dialog.simple_message("I have found what i have been looking for. I found some valuables buried here. Thanks for your help.");
				}
			if(isDisposed())
				return;
		}
		for(Object521 other : getCollisions(Object521.class))
		{
			if (global.nwhathevva==1)
			{
				global.nwhathevva = 2;
				sound_play("monny");
				other.destroy();
				AR1Dialog.simple_message("You found shovel.");
			}
			if(isDisposed())
				return;
		}
		for(Object523 other : getCollisions(Object523.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.inngrodd1>2)
							if (global.blackmushz>2)
								if (global.robopartsouv>2)
									if (global.nwhathevva>2)
										if (global.gsgfhfs<2)
										{
											if (show_question("Enter?"))
											{
												transition_kind(0);
												room_goto("thenbodss");
											}
										}
										else
											show_message("Closed.");
					}
				}.start();

			}
			if(isDisposed())
				return;
		}
		for(Object524 other : getCollisions(Object524.class))
		{
			move_bounce_all(false);
			hspeed+=-9;
			vspeed+=-2;
			if(other.inv<1)
			{
				sound_play("crash");
				other.inv = 30;
				other.life += -1;
				instance_create(x+hspeed*5,y+vspeed*5,Explodd1.class);
				if (other.life<3)
				{
					instance_create(other.x+-96,other.y+-48,Explodd2.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-random(48),other.y+-random(48),Explodd1.class);
				}
			}
			if(isDisposed())
				return;
		}
		for(Treeguy other : getCollisions(Treeguy.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					new AR1Dialog()
					{

						@Override
						public void dialog() throws ConverseException, SleepException
						{
							if (global.spockn7==0)
							{
								show_message("I am watching this tree. I am able to communicate with it. It is very old and wise.");
								other.sprite = Sprite.get("sprite330");
								image_xscale=1;
								image_yscale=1;
								sleep(100);

								sleep(1000);

								if (global.abzolniu<1)
								{
									show_message("It sees what you are up to, your task.");
									show_message("You must defeat the evil and destroy the robots.");
								}
								if (global.abzolniu==1 && global.gsgfhfs==0)
								{
									show_message("It sees what you are up to, your task.");
									show_message("You have destroyed the robots, but there is one more thing you have to do.");
									show_message("There is an evil animal trying to revieve the evil powers.");
								}
								if (global.gsgfhfs==1)
								{
									show_message("It says you have completed you task.");
								}
							}
							if (global.abzolniu<1)
							{
								if (global.opennewye3==1 && global.opennewye4==1)
									show_message("You have all the big keys and you must enter the door left of the town. You should bring some potions and stuff.");
								else
									show_message("You must get the remaining big keys.");
							}
							if (global.abzolniu==1 && global.gsgfhfs==0)
								show_message("The evil animal is hiding inside a door above the town. To get there you must get four small weird keys. The way to get to the door is left in the mountains. The keys are owned by animals that need help. Help them and you will get the keys.");
							if (global.gsgfhfs==1)
								show_message("We thank you for destroying the evil powers.");
							other.sprite = Sprite.get("treesfrien");
							global.spockn7 = 1;
						}
					}.start();
				}
			other.sprite = Sprite.get("treesfrien");
			if(isDisposed())
				return;
		}
		for(Tobiich other : getCollisions(Tobiich.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = 0;
				goIn(500, "beeache");
			}
			if(isDisposed())
				return;
		}
		for(Frombiich other : getCollisions(Frombiich.class))
		{
			global.uxyz = 6;
			goIn(500, "hiddenplace");
			if(isDisposed())
				return;
		}
		for(Toundr other : getCollisions(Toundr.class))
		{
			global.uxyz = -1;
			goIn(500, "underwater");
			if(isDisposed())
				return;
		}
		for(Fromundr other : getCollisions(Fromundr.class))
		{
			global.uxyz = 1;
			goIn(500, "beeache");
			if(isDisposed())
				return;
		}
		for(Watergem other : getCollisions(Watergem.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.element1 = 1;
				sound_play("monny");
				other.destroy();
				AR1Dialog.simple_message("You found Jewel of Water.");
			}
			if(isDisposed())
				return;
		}
		for(Firegem other : getCollisions(Firegem.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.element2 = 1;
				sound_play("monny");
				other.destroy();
				AR1Dialog.simple_message("You found Jewel of Fire.");
			}
			if(isDisposed())
				return;
		}
		for(Earthgem other : getCollisions(Earthgem.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.element3 = 1;
				sound_play("monny");
				other.destroy();
				AR1Dialog.simple_message("You found Jewel of Earth.");
			}
			if(isDisposed())
				return;
		}
		for(Airgem other : getCollisions(Airgem.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.element4 = 1;
				sound_play("monny");
				other.destroy();
				AR1Dialog.simple_message("You found Jewel of Air.");
			}
			if(isDisposed())
				return;
		}
		for(Altergems other : getCollisions(Altergems.class))
		{
			if (global.element1>0)
				if (global.element2==1)
					if (global.element3==1)
						if (global.element4==1)
							if (still==0 && keyboard_check_pressed(VK.UP))
							{
								new AR1Dialog()
								{

									@Override
									public void dialog() throws ConverseException, SleepException
									{
										if (global.elementye==0)
										{
											if (show_question("Do you want to see the power of the gems?"))
											{
												global.uxyz = -1;
												sleep(500);

												{
													transition_kind(0);
													room_goto("lmntboss");
												}
											}
										}
										else
											show_message("You have the key of the elements.");
									}
								}.start();

							}
			if(isDisposed())
				return;
		}
		for(Guylooklava other : getCollisions(Guylooklava.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					AR1Dialog.simple_message("The ground suddenly opened itself and started smoking!");
				}
			if(isDisposed())
				return;
		}
		for(Badlava other : getCollisions(Badlava.class))
		{
			if (vspeed>0)
				vspeed=-vspeed;
			vspeed+=-2;
			sound_play("ough");
			global.life += -12;
			if(isDisposed())
				return;
		}
		for(Guyinlava other : getCollisions(Guyinlava.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					AR1Dialog.simple_message("Strange place, this. If you go in that door you come out another door, but if you go in there you go somewhere else.");
				}
			if(isDisposed())
				return;
		}
		for(Logava other : getCollisions(Logava.class))
		{
			global.uxyz = -1;
			goIn(500, "lavaplace");
			if(isDisposed())
				return;
		}
		for(Lromfava other : getCollisions(Lromfava.class))
		{
			global.uxyz = 6;
			goIn(500, "jungltown");
			if(isDisposed())
				return;
		}
		for(Elemboss other : getCollisions(Elemboss.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				other.inv = 30;
				other.life += -global.sharpness;
				if(other.life < 0)
				{
					instance_create(other.x+17,other.y+0,Explodd3.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Evilreactobj other : getCollisions(Evilreactobj.class))
		{
			if(other.inv<1)
			{
				sound_play("crash");
				move_bounce_all(false);
				vspeed=vspeed/2;
				other.inv = 30;
				other.life += -global.sharpness;
				if(other.life < 0)
				{
					instance_create(other.x+17,other.y+0,Explodd3.class);
					for (int i = 0; i<4; i++)
						instance_create(other.x+-12+random(48),other.y+-32+random(48),Explodd1.class);
					other.alarm[0] = 6;
				}
			}
			if(isDisposed())
				return;
		}
		for(Movflour other : getCollisions(Movflour.class))
		{
			if (y<other.y+36)
			{
				if (hspeed<6)
					hspeed+=0.75;
				double maxdist = Math.abs(vspeed);
				vspeed=0;
				y=other.y;
				move_contact_solid(270, 32);
			}
			else
				move_bounce_solid(false);
			if(isDisposed())
				return;
		}
		for(Outmachan other : getCollisions(Outmachan.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				if (global.reactdeadevil==1)
					AR1Dialog.simple_message("The reactor and the machinery has been infected by a virus or something and it is all evil! You must help us!");
				else if (global.reactdeadevil==2)
					AR1Dialog.simple_message("I see you have destroyed the evil reactor. Now we must rebuild the machines.");

			}
			if(isDisposed())
				return;
		}
		for(Object605 other : getCollisions(Object605.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				AR1Dialog.simple_message("We are all grateful you have saved our jungle.");

			}
			if(isDisposed())
				return;
		}
		for(Object606 other : getCollisions(Object606.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				AR1Dialog.simple_message("We like you. You have saved our jungle.");

			}
			if(isDisposed())
				return;
		}
		for(Object607 other : getCollisions(Object607.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				if (other.asd<2)
				{
					other.asd++;
					AR1Dialog.simple_message("We like you. You have saved our jungle.");
				}
				else if (other.asd==2)
				{
					instance_create(other.x+0,other.y+0,Parroteat.class);
					still = 1;
					other.asd++;
				}
			}
			if(isDisposed())
				return;
		}
		for(Brpolac other : getCollisions(Brpolac.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						if (global.elementye>0)
						{
							global.uxyz = -1;
							sleep(500);

							{
								transition_kind(0);
								room_goto("room99");
							}
						}
						else
							show_message("CLOSED!");
					}
				}.start();

			}
			if(isDisposed())
				return;
		}
		for(Lroneltown other : getCollisions(Lroneltown.class))
		{
			global.uxyz = 2;
			goIn(500, "bossright1");
			if(isDisposed())
				return;
		}
		for(Toerth other : getCollisions(Toerth.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "erth");
			}
			if(isDisposed())
				return;
		}
		for(Towat other : getCollisions(Towat.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "whtt");
			}
			if(isDisposed())
				return;
		}
		for(Tofir other : getCollisions(Tofir.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "firr");
			}
			if(isDisposed())
				return;
		}
		for(Toairrr other : getCollisions(Toairrr.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.uxyz = -1;
				goIn(500, "arri");
			}
			if(isDisposed())
				return;
		}
		for(Fromerth other : getCollisions(Fromerth.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.createc = 1;
				global.uxyz = 0;
				goIn(500, "room99");
			}
			if(isDisposed())
				return;
		}
		for(Fromwat other : getCollisions(Fromwat.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.controlc = 1;
				global.uxyz = 1;
				goIn(500, "room99");
			}
			if(isDisposed())
				return;
		}
		for(Frofir other : getCollisions(Frofir.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.destroyc = 1;
				global.uxyz = 2;
				goIn(500, "room99");
			}
			if(isDisposed())
				return;
		}
		for(Froria other : getCollisions(Froria.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				global.gravityc = 1;
				global.uxyz = 3;
				goIn(500, "room99");
			}
			if(isDisposed())
				return;
		}
		for(Gronsymb other : getCollisions(Gronsymb.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						show_message("I symbolize earth.");
						show_message("When you leave this room you will get the power to create.");
						show_message("Press left mouse button to create. To choose what to create, press Z and X. The object you have chosen will be shown on the screen.");
						show_message("I warn you though; you should save before changing things. It may crash the game.");
					}
				}.start();

			}
			if(isDisposed())
				return;
		}
		for(Wattsymb other : getCollisions(Wattsymb.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						show_message("I see you have found the town of elements. You will recieve a gift from me.");
						show_message("I symbolize water.");
						show_message("When you leave this room you will be able to control evil.");
						show_message("To make the world evil, press V. To make the world good again, press B.");
						show_message("I warn you though; you should save before changing things. It may crash the game.");
					}
				}.start();

			}
			if(isDisposed())
				return;
		}
		for(Frirsymb other : getCollisions(Frirsymb.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						show_message("Congratulations. You have found the town of elements.");
						show_message("I symbolize fire.");
						show_message("When you leave this room you will get the power of destruction.");
						show_message("To destroy something press right mouse button over what you want to destroy.");
						show_message("I warn you though; you should save before changing things. It may crash the game.");

					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Arirsymb other : getCollisions(Arirsymb.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException, SleepException
					{
						show_message("You have found the way to this town. I symbolize air.");
						show_message("When you leave this room you will be able to control gravity.");
						show_message("To rotate gravity 90 degrees, press G. If you want it back to normal, press G until it is normal.");
						show_message("I warn you though; you should save before changing things. It may crash the game.");

					}
				}.start();
			}
			if(isDisposed())
				return;
		}
		for(Objwakot other : getCollisions(Objwakot.class))
		{
			alarm[3] = 3;
			if (still==0 && keyboard_check_pressed(VK.UP))
				if (hy==0)
				{
					hy = 1;
					AR1Dialog.simple_message("Hello. I hear you have wiped out the robots. There is noone working in this mine, but it is fun walking here.");
				}
			if(isDisposed())
				return;
		}
		for(Lavagets other : getCollisions(Lavagets.class))
		{
			if (still==0 && keyboard_check_pressed(VK.UP))
			{
				{
					Lavagets far = instance_furthest(x,y,Lavagets.class);
					x=far.x+32;
					y=far.y+54;
					xprevious = x;
					yprevious = y;
				}
				sound_play("weitle");
				return;
			}
			if(isDisposed())
				return;
		}
		super.handleCollisions();
	}
	@Override
	public void endCollisions()
	{
    	//Special hack to bugfix stuckage while touching bridge/diagonal/platform and solid ground
		//those have a fake solid attached which will generate stuckage if also touching solid, disable this temporarily
    	instances(meetingCache, Misksolid.class);
    	instances(meetingCache, Immetdest.class);
    	for(int i = 0; i<meetingCache.size(); i++)
    	{
    		Entity e = meetingCache.get(i);
			e.solid = false;
    	}
    	meetingCache.clear();
		super.endCollisions();
		//enable again
		instances(meetingCache, Misksolid.class);
    	instances(meetingCache, Immetdest.class);
    	for(int i = 0; i<meetingCache.size(); i++)
    	{
    		Entity e = meetingCache.get(i);
			e.solid = true;
    	}
    	meetingCache.clear();
	}
	
	@Override
	public void keyEvent(KeyEventType type, VK key)
	{
		switch (type)
		{
		case DOWN:
			switch (key)
			{
			case LEFT:
				if (nomv==0)
					if (still==0)
					{
						if (global.cha==0)
						{
							sprite = Sprite.get("ywalkl");
							image_xscale=1;
							image_yscale=1;
						}
						if (global.cha==1)
						{
							sprite = Sprite.get("kwalkl");
							image_xscale=1;
							image_yscale=1;
						}
						if (global.cha==2)
						{
							sprite = Sprite.get("fwalkl");
							image_xscale=1;
							image_yscale=1;
						}
						alarm[0] = 2;
						if (global.poisoned==0)
						{
							if (hspeed>-6)
								hspeed+=-0.45;
						}
						else
						{
							if (hspeed>-8)
								hspeed+=-0.45;
						}
						image_speed = -hspeed/3;
						right = 0;
					}
				break;
			case RIGHT:
				if (nomv==0)
					if (still==0)
					{
						if (global.cha==0)
						{
							sprite = Sprite.get("ywalkr");
							image_xscale=1;
							image_yscale=1;
						}
						if (global.cha==1)
						{
							sprite = Sprite.get("kwalkr");
							image_xscale=1;
							image_yscale=1;
						}
						if (global.cha==2)
						{
							sprite = Sprite.get("fwalkr");
							image_xscale=1;
							image_yscale=1;
						}
						alarm[0] = 2;
						if (global.poisoned==0)
						{
							if (hspeed<6)
								hspeed+=0.45;
						}
						else
						{
							if (hspeed<8)
								hspeed+=0.45;
						}
						image_speed = hspeed/3;
						right = 1;
					}
				break;
			default:
				super.keyEvent(type, key);
				break;
			}
			break;
		case PRESS:
			switch (key)
			{
			case ENTER:
				System.gc();
				new AR1Dialog()
				{
					@Override
					public void dialog() throws ConverseException, SleepException
					{
						int q = show_menu(null, "Resume", "Use Potion (U)", "Key Items (I)", "World Map (M)", "Help (F1)", "Main Menu");
						switch (q)
						{
						case 0:
							break;
						case 1:
							showUseItem();
							break;
						case 2:
							showItems();
							break;
						case 3:
							showMap();
							break;
						case 4:
							showHelp();
							break;
						case 5:
							if(show_question("Unsaved progress will be lost. Are you sure?")) {
				            	sound_stop_all();
				            	midi.midiStop();
								game_restart();
							}
							break;
						default:
							break;
						}
					}
					@Override
					protected void renderDialog() 
					{
						draw_set_color(c_black);
						draw_set_alpha(0.5);
						draw_rectangle(0, 0, 640, 480, false);

						draw_set_color(c_red);
						draw_set_alpha(1.0);
						draw_set_font(AR1Fonts.A_26);
						draw_set_halign(fa_center);
						draw_set_valign(fa_bottom);
						draw_text(320,100,"PAUSED");
						super.renderDialog();
					}
				}.start();
				break;
			case SPACE:
				if (still==0)
					if (!place_free(x+0,y+vspeed+3))
						if (nomv==0)
						{
							alarm[0] = 0;
							image_speed = 0.1;
							nomv = 1;
							if (global.cha==0)
							{
								if (right==1)
								{
									sprite = Sprite.get("ysitr");
									image_xscale=1;
									image_yscale=1;
								}
								else
								{
									sprite = Sprite.get("ysitl");
									image_xscale=1;
									image_yscale=1;
								}
							}
							if (global.cha==1)
							{
								if (right==1)
								{
									sprite = Sprite.get("ksitr");
									image_xscale=1;
									image_yscale=1;
								}
								else
								{
									sprite = Sprite.get("ksitl");
									image_xscale=1;
									image_yscale=1;
								}
							}
							if (global.cha==2)
							{
								if (right==1)
								{
									sprite = Sprite.get("fsitr");
									image_xscale=1;
									image_yscale=1;
								}
								else
								{
									sprite = Sprite.get("fsitl");
									image_xscale=1;
									image_yscale=1;
								}
							}
						}
				break;
			case DOWN:
				if (still==0)
					if (!place_free(x+0,y+vspeed+1))
						if (nomv==0)
						{
							image_speed = 0.1;
							alarm[0] = 0;
							alarm[1] = 3;
							nomv = 1;
							if (global.cha==0)
							{
								if (right==1)
								{
									sprite = Sprite.get("ysitr");
									image_xscale=1;
									image_yscale=1;
								}
								else
								{
									sprite = Sprite.get("ysitl");
									image_xscale=1;
									image_yscale=1;
								}
							}
							if (global.cha==1)
							{
								if (right==1)
								{
									sprite = Sprite.get("ksitr");
									image_xscale=1;
									image_yscale=1;
								}
								else
								{
									sprite = Sprite.get("ksitl");
									image_xscale=1;
									image_yscale=1;
								}
							}
							if (global.cha==2)
							{
								if (right==1)
								{
									sprite = Sprite.get("fsitr");
									image_xscale=1;
									image_yscale=1;
								}
								else
								{
									sprite = Sprite.get("fsitl");
									image_xscale=1;
									image_yscale=1;
								}
							}
						}
				break;
			case B:
				if (global.controlc>0)
					if (global.abzolniu==0)
					{
						sound_play("windups");
						global.abzolniu = 1;
						global.axxx = x;
						global.ayyy = y;
						new AR1Dialog()
						{

							@Override
							public void dialog() throws ConverseException, SleepException
							{
								sleep(200);

								{
									transition_kind(0);
									room_restart();
								}
							}
						}.start();
					}
				break;
			case M:
				showMap();
				break;
			case G:
				if (global.gravityc>0)
					gravity_direction+=90;
				break;
			case Q:
				if (!place_free(x+0,y+0))
				{
					int[] dx = {1,-1,0,0};
					int[] dy = {0,0,1,-1};
					
					int d = 0, l = 32;
					while(!place_free(x+l*dx[d],y+l*dy[d]))
					{
						d++;
						if(d>=4)
						{
							d=0;
							l+=32;
						}
					}
					x += l*dx[d];
					y += l*dy[d];
				}
				break;
			case U:
				showUseItem();
				break;
			case V:
				if (global.controlc>0)
					if (global.abzolniu==1)
					{
						sound_play("badstart");
						global.abzolniu = 0;
						global.axxx = x;
						global.ayyy = y;

						new AR1Dialog()
						{

							@Override
							public void dialog() throws ConverseException, SleepException
							{
								sleep(200);
								{
									transition_kind(0);
									room_restart();
								}
							}
						}.start();
					}
				break;
			case I:
				showItems();
				break;
			case F1:
				showHelp();
				break;
			case F5:
				game_save("AR1_quicksave"+global.currentFile+".sav");
				break;
			case F6:
				game_load("AR1_quicksave"+global.currentFile+".sav");
				break;
			default:
				super.keyEvent(type, key);
				break;
			}
			break;
		case RELEASE:
			switch (key)
			{
			case SPACE:
				//JUMP!
				if (still==0)
					if (!place_free(x+0,y+vspeed+3))
					{
						if (global.cha==0)
						{
							if (right==1)
							{
								sprite = Sprite.get("ywalkr");
								image_xscale=1;
								image_yscale=1;
							}
							else
							{
								sprite = Sprite.get("ywalkl");
								image_xscale=1;
								image_yscale=1;
							}
						}
						if (global.cha==1)
						{
							if (right==1)
							{
								sprite = Sprite.get("kwalkr");
								image_xscale=1;
								image_yscale=1;
							}
							else
							{
								sprite = Sprite.get("kwalkl");
								image_xscale=1;
								image_yscale=1;
							}
						}
						if (global.cha==2)
						{
							if (right==1)
							{
								sprite = Sprite.get("fwalkr");
								image_xscale=1;
								image_yscale=1;
							}
							else
							{
								sprite = Sprite.get("fwalkl");
								image_xscale=1;
								image_yscale=1;
							}
						}
						vspeed=-global.jsped;
						y+=-8;
						alarm[0] = 5;
					}
				nomv = 0;
				break;
			case DOWN:
				if (still==0)
					if (!place_free(x+0,y+vspeed+1))
					{
						alarm[0] = 2;
						nomv = 0;
						if (global.cha==0)
						{
							if (right==1)
							{
								sprite = Sprite.get("ysitr");
								image_xscale=1;
								image_yscale=1;
							}
							else
							{
								sprite = Sprite.get("ysitl");
								image_xscale=1;
								image_yscale=1;
							}
						}
						if (global.cha==1)
						{
							if (right==1)
							{
								sprite = Sprite.get("ksitr");
								image_xscale=1;
								image_yscale=1;
							}
							else
							{
								sprite = Sprite.get("ksitl");
								image_xscale=1;
								image_yscale=1;
							}
						}
						if (global.cha==2)
						{
							if (right==1)
							{
								sprite = Sprite.get("fsitr");
								image_xscale=1;
								image_yscale=1;
							}
							else
							{
								sprite = Sprite.get("fsitl");
								image_xscale=1;
								image_yscale=1;
							}
						}
					}
				break;
			default:
				super.keyEvent(type, key);
				break;
			}
			break;
		default:
			super.keyEvent(type, key);
			break;
		}
	}
}
