package owg.lgm.ar1;

import owg.lgm.*;
import owg.lgm.ar1.accessories.AR1Dialog;
import owg.lgm.ar1.accessories.AR1Scripts;
import owg.lgm.in.KeyEventType;
import owg.lgm.in.KeyListener;
import owg.lgm.in.VK;
import owg.lgm.util.Letterbox;

import static owg.lgm.GMLib.*;
import static owg.lgm.plaf.Engine.EN;

public class Exitnot extends Entity implements KeyListener
{
	public Exitnot(double x, double y)
	{
		super(x, y, 0, true, false, false, null, null);
	}
	protected Exitnot(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
	{
		super(x, y, depth, persistent, visible, solid, sprite, mask);
	}
	@Override
	public void keyEvent(KeyEventType type, VK key)
	{
		switch (type)
		{
		case PRESS:
			switch (key)
			{
			case ESCAPE:
				new AR1Dialog()
				{

					@Override
					public void dialog() throws ConverseException
					{
			            int qhu=show_message_ext("QUIT!?!","No","Restart","Quit");
			            if (qhu==1) {
			            	sound_stop_all();
			            	AR1Scripts.midi.midiStop();
			            	game_restart();
			            } else if (qhu==2)
			            	game_end();
					}
				}.start();
				break;
			case F2:
				EN.setVSync(!EN.getVSync());
				break;
			case F3:
				System.setProperty(Letterbox.INTEGER_SCALING, String.valueOf(!("true".equals(System.getProperty(Letterbox.INTEGER_SCALING)))));
				break;
			case F4:
				EN.setFullscreen(!EN.isFullscreen());
				break;
			default:
				super.keyEvent(type, key);
				break;
			}
			break;
		default:
			super.keyEvent(type, key);
			break;
		}
	}
}
