package owg.lgm.ar1;

import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.ar1.accessories.AR1Scripts.*;

import owg.lgm.Entity;

public class Muzika extends Entity
{
	public Muzika(double x, double y)
	{
		super(x, y, 0, true, false, false, null, null);
	}

	public Muzika(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String spriteName, String maskName)
	{
		super(x, y, depth, persistent, visible, solid, spriteName, maskName);
	}
	
	@Override
	public void createEvent()
	{
		initMidi();
	}
	
	@Override
	public void step()
	{
		if(global.mzc == null)
		{
			if(midi.clientPlaying != null)
				midi.midiStop();
		}
		else if(!(global.mzc+".mid").equals(midi.clientPlaying))
			midi.midiPlay(global.mzc+".mid", true);
	}
}
