package owg.lgm.ar1;

import owg.lgm.*;
import owg.lgm.ar1.accessories.AR1Dialog;
import owg.lgm.ar1.stuff.back.Object607;

import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.GMLib.*;

public class Parroteat extends Entity
{
    public Parroteat(double x, double y)
    {
        super(x, y, 1, false, true, false, "deadparrot", null);
    }
    protected Parroteat(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
    {
        super(x, y, depth, persistent, visible, solid, sprite, mask);
    }
    @Override
    public void createEvent()
    {
        image_speed = 1/45.0;
        sound_play("splett");
        sound_play("eatsnd");
        instance_destroy_all(Object607.class);
        global.eatn = 1;
    }
    @Override
    public void step()
    {
    	Animal animal = instance(Animal.class);
    	if(animal != null)
        {
            x=animal.x+animal.sprite.width/2.5;
            y=animal.y;
        }
    }
    @Override
    public void animationEnd()
    {
        destroy();
    	Animal animal = instance(Animal.class);
    	if(animal != null)
        {
    		animal.still = 0;
        }
    	new AR1Dialog()
		{
			@Override
			public void dialog() throws ConverseException
			{
		        show_message("Your claw level is upgraded!");
		        double mk = global.sharpreal/4.0;
		        global.sharpness += 1.0/mk + Math.pow(mk-1, 1.5)/20;
		        global.sharpreal += 1;
		        sound_play("monny");
			}
		}.start();
    }
}
