package owg.lgm.ar1.enemy;

import owg.lgm.*;
import owg.lgm.ar1.Invable;
import owg.lgm.ar1.Tuudna;
import owg.lgm.ar1.fallers.Fall55;

import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.GMLib.*;

public class Fakerhole extends Invable implements Collider
{
    public Fakerhole(double x, double y)
    {
        super(x, y, 0, false, true, false, "sprite229", null);
    }
    protected Fakerhole(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
    {
        super(x, y, depth, persistent, visible, solid, sprite, mask);
    }
    @Override
    public void createEvent()
    {
        if (global.abzolniu>0) {
	        destroy();
			return;
		}
        inv = 0;
        life = 3;
        alarm[1] = (short)(60);
        hspeed=1;
    }
    @Override
    public void render()
    {
        draw_sprite(sprite,image_index,x+0,y+0);
    }
    @Override
    public void alarmTriggered(int alarmIndex)
    {
        switch (alarmIndex)
        {
            case 0:
            destroy();
            if (floor(random(2-1))==0)
            instance_create(x+0,y+0,Fall55.class);
            break;
            case 1:
            alarm[2] = (short)(60);
            setSpeed(1);
            break;
            case 2:
            alarm[1] = (short)(60);
            setSpeed(4);
            break;
            default:
            super.alarmTriggered(alarmIndex);
            break;
        }
    }
    @Override
    public void handleCollisions()
    {
        for(@SuppressWarnings("unused") Tuudna other : getCollisions(Tuudna.class))
        {
            hspeed=-hspeed;
            if(isDisposed())
            return;
        }
        super.handleCollisions();
    }
}
