package owg.lgm.ar1.enemy;

import owg.lgm.ar1.Animal;
import owg.lgm.ar1.explodd.Explodd3;
import owg.lgm.ar1.fallers.Fall55;

import static owg.lgm.GMLib.*;

public class Object528 extends Enemy1
{
	public Object528(double x, double y)
	{
		super(x, y, 0, false, true, false, "en4gun", null);
	}
	protected Object528(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
	{
		super(x, y, depth, persistent, visible, solid, sprite, mask);
	}

	double dir;
	int yeh;

	@Override
	public void createEvent()
	{
		inv = 0;
		life = 21;
		alarm[1] = (short)(120);
		dir = 0;
		yeh = 0;
		x+=-32;
	}
	@Override
	public void destroyEvent()
	{
		instance_create(x+0,y+0,Explodd3.class);
	}
	@Override
	public void step()
	{
		Animal animal = instance(Animal.class);
		if (animal != null)
			dir = point_direction(x,y,animal.x,animal.y);
	}
	@Override
	public void render()
	{
		draw_sprite(sprite,dir*16.0/360,x+0,y+0);
	}
	@Override
	public void alarmTriggered(int alarmIndex)
	{
		Animal animal = instance(Animal.class);
		switch (alarmIndex)
		{
		case 0:
			destroy();
			if (floor(random(2-1))==0)
				instance_create(x+0,y+0,Fall55.class);
			if (floor(random(2-1))==0)
				instance_create(x+0,y+0,Shotblb1.class);
			break;
		case 1:
			alarm[1] = (short)(230);
			alarm[2] = (short)(10);
			if (animal != null)
				if (distance_to_object(animal)<512)
					instance_create(x+0,y+0,Shotblb1.class);
			break;
		case 2:
			alarm[3] = (short)(10);
			if (animal != null)
				if (distance_to_object(animal)<512)
					instance_create(x+0,y+0,Shotblb1.class);
			break;
		case 3:
			if (animal != null)
				if (distance_to_object(animal)<512)
					instance_create(x+0,y+0,Shotblb1.class);
			break;
		default:
			super.alarmTriggered(alarmIndex);
			break;
		}
	}
}
