package owg.lgm.ar1.ingredianser;

import owg.lgm.*;
import owg.lgm.ar1.Animal;
import owg.lgm.ar1.accessories.AR1Dialog;
import owg.lgm.in.VK;

import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.GMLib.*;

public class Ingnr6 extends Entity implements Collider
{
    public Ingnr6(double x, double y)
    {
        super(x, y, 0, false, true, false, "ing6", null);
    }
    protected Ingnr6(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
    {
        super(x, y, depth, persistent, visible, solid, sprite, mask);
    }
    @Override
    public void createEvent()
    {
        alarm[0] = (short)(2);
    }
    @Override
    public void alarmTriggered(int alarmIndex)
    {
        switch (alarmIndex)
        {
            case 0:
            if (global.inngrodd6>0)
            destroy();
            break;
            default:
            super.alarmTriggered(alarmIndex);
            break;
        }
    }
    @Override
    public void handleCollisions()
    {
        for(@SuppressWarnings("unused") Animal other : getCollisions(Animal.class))
        {
            if (keyboard_check_pressed(VK.UP))
            {
                destroy();
                global.inngrodd6 = 1;
                new AR1Dialog()
				{
					@Override
					public void dialog() throws ConverseException
					{
		                show_message("You have found Strange Red Ball.");
		                sound_play("monny");
					}
				}.start();
            }
            if(isDisposed())
            return;
        }
        super.handleCollisions();
    }
}
