package owg.lgm.ar1.onlyonce;

import owg.lgm.*;
import owg.lgm.ar1.Animal;

import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.GMLib.*;

public class Nevamord6 extends Entity implements Collider
{
	public Nevamord6(double x, double y)
	{
		super(x, y, 0, false, true, false, "greatcalur", null);
	}
	protected Nevamord6(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
	{
		super(x, y, depth, persistent, visible, solid, sprite, mask);
	}
	@Override
	public void createEvent()
	{
		image_single(random(image_number()));
		alarm[0] = (short)(2);
	}
	@Override
	public void alarmTriggered(int alarmIndex)
	{
		switch (alarmIndex)
		{
		case 0:
			if (global.itemtaken6==1)
				destroy();
			break;
		default:
			super.alarmTriggered(alarmIndex);
			break;
		}
	}
	@Override
	public void handleCollisions()
	{
		for(@SuppressWarnings("unused") Animal other : getCollisions(Animal.class))
		{
			destroy();
			global.score += 15;
			sound_play("monny");
			global.itemtaken6 = 1;
			if(isDisposed())
				return;
		}
		super.handleCollisions();
	}
}
