package owg.lgm.ar1.stuff.animals;

import static owg.lgm.ar1.accessories.AR1Globals.global;

import owg.lgm.Collider;
import owg.lgm.Entity;
import owg.lgm.Sprite;
import owg.lgm.ar1.Tuudna;

public class Objwakot extends Entity implements Collider
{
    public Objwakot(double x, double y)
    {
        super(x, y, 0, false, true, false, "hegehog", null);
    }
    protected Objwakot(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
    {
        super(x, y, depth, persistent, visible, solid, sprite, mask);
    }
    @Override
    public void createEvent()
    {
        image_speed = 0.5;
        if (!(global.abzolniu>0))
        	destroy();
        hspeed=2;
        image_speed = 0.4;
    }
    @Override
    public void handleCollisions()
    {
        for(@SuppressWarnings("unused") Tuudna other : getCollisions(Tuudna.class))
        {
        	if(alarm[0] <= 0)
        		hspeed=-hspeed;
            if (hspeed>0)
            {
                sprite = Sprite.get("hegehog");
                image_xscale=1;
                image_yscale=1;
            }
            else
            {
                sprite = Sprite.get("sprite374");
                image_xscale=1;
                image_yscale=1;
            }
            alarm[0] = 4;
            if(isDisposed())
            return;
        }
        super.handleCollisions();
    }
}
