package owg.lgm.ar1.stuff.boss;

import owg.lgm.*;
import owg.lgm.ar1.Invable;
import owg.lgm.ar1.enemy.Object591;
import owg.lgm.ar1.explodd.Explodd3;
import owg.lgm.ar1.stuff.special.Object500;

import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.GMLib.*;

public class Evilreactobj extends Invable
{
	public Evilreactobj(double x, double y)
	{
		super(x, y, 2, false, true, false, "evreact", "mioeshk");
	}
	protected Evilreactobj(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
	{
		super(x, y, depth, persistent, visible, solid, sprite, mask);
	}
	@Override
	public void createEvent()
	{
		inv = 0;
		life = 100;
		alarm[1] = (short)(300);
		alarm[2] = (short)(450);
	}

	Sprite mioeshk = Sprite.get("mioeshk");

	@Override
	public void render()
	{
		draw_sprite(sprite,0,x+0,y+0);
		draw_sprite(mioeshk,0,x+0,y+0);
	}
	@Override
	public void alarmTriggered(int alarmIndex)
	{
		switch (alarmIndex)
		{
		case 0:
		{
			sound_stop_all();
			global.mzc=null;
		}
		destroy();

		instance_destroy_all(Boss3killst.class);
		instance_destroy_all(Standomen.class);
		instance_create(0,0,Object604.class);
		for (int i = 0; i<7; i++)
		{
			instance_create(x+128,y+128,Boomfall.class);
			instance_create(x+random(256),y+random(256),Explodd3.class);
		}
		global.reactdeadevil = 2;
		break;
		case 1:
			alarm[1] = (short)(50+life+random(50));
			instance_create(x+128,y+128,Object591.class);
			break;
		case 2:
			instance_create(room_width()-214,632,Object500.class);
			alarm[2] = (short)(450);
			break;
		default:
			super.alarmTriggered(alarmIndex);
			break;
		}
	}
}
