package owg.lgm.ar1.stuff.boss;

import owg.lgm.*;
import owg.lgm.ar1.Animal;
import owg.lgm.ar1.Tuudna;
import owg.lgm.ar1.enemy.Laser1;
import owg.lgm.ar1.enemy.Object415;
import owg.lgm.ar1.enemy.Object499;
import owg.lgm.ar1.enemy.Poisarrw;
import owg.lgm.ar1.fallers.Fall1515;
import owg.lgm.ar1.stuff.evilballstuf.Boss3ballst;
import owg.lgm.ar1.stuff.special.Object500;

import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.GMLib.*;

public class Object501 extends HEVE2 implements Collider
{
    public Object501(double x, double y)
    {
        super(x, y, 0, false, true, false, "bigsatan", "bigsatan");
    }
    protected Object501(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
    {
        super(x, y, depth, persistent, visible, solid, sprite, mask);
    }
    
    Entity moog, moog2;
    
    double dir1, dir2;
    double sp, sp2;
    double dirsp, spsp;
    double oghdir;
    double resumeDir;
    
    @Override
    public void createEvent()
    {
        vspeed=-1;
        {
            //rotating spears idea remember (create, direction+45, create, wait)
            //Skrulling som vil ha deg til aa finne masse skrap hun kan ha i gryta.
        }
        alarm[2] = (short)(120);
        alarm[3] = (short)(300);
        {
            moog2=instance_create(x,y,Boss3ballst.class);
            ((Boss3ballst)moog2).m=this;
            moog2.depth=1;
        }
        alarm[4] = (short)(160);
        alarm[6] = (short)(60);
        alarm[5] = (short)(150);
        inv = 0;
        he = 0;
        dir2 = 135;
        ve = 0;
        life = 150;
        he2 = 0;
        ve2 = 0;
        dir1 = 45;
        dirsp = 1;
        sp = 192;
        spsp = 0;
        alarm[1] = (short)(120);
        sp2 = 192;
        oghdir = 0;
    }
    @Override
    public void step()
    {
        dir1 += dirsp;
        dir2 += -dirsp;
        sp2 += spsp;
        he2 = lengthdir_x(sp2, dir2)/1.5;
        ve2 = lengthdir_y(sp2, dir2);
        sp += spsp;
        he = lengthdir_x(sp, dir1);
        ve = lengthdir_y(sp, dir1);
    }
    
    Sprite smsatan = Sprite.get("smsatan");
    
    @Override
    public void render()
    {
        double d = 1;
        for (int i = 0; i<10; i++)
        {
            d += -1.0/10.0;
            draw_sprite(smsatan,-1,x+-he2*d,y+-ve2*d);
        }
        draw_sprite(sprite,-1,x+0,y+0);
    }
    @Override
    public void alarmTriggered(int alarmIndex)
    {
        switch (alarmIndex)
        {
            case 0:
            {
                if(moog2 != null)
                {
                    moog2.destroy();
                    moog2 = null;
                }
                sound_stop_all();
            }
            global.mzc = null;
            destroy();
            
            instance_destroy_all(Object500.class);
            instance_destroy_all(Object499.class);
            instance_create(0,0,Object503.class);
            instance_create(x+0,y+0,Poisarrw.class);
            instance_create(x+-32,y+0,Fall1515.class);
            for (int i = 0; i<7; i++)
            instance_create(x+0,y+0,Boomfall.class);
            for (int i = 0; i<12; i++)
            instance_create(x+0,y+0,Bigboom.class);
            break;
            case 1:
            spsp = -1;
            alarm[2] = (short)(32);
            sp = 192;
            sp2 = 192;
            break;
            case 2:
            spsp = 1;
            sp = 160;
            alarm[1] = (short)(32);
            sp2 = 160;
            break;
            case 3:
            setDirSp(resumeDir, 2);
            break;
            case 4:
            alarm[4] = (short)(190);
            if (floor(random(8-1))==0)
            instance_create(x+0,y+0,Poisarrw.class);
            else
            {
                if (floor(random(2-1))==0)
                instance_create(x+0,y+0,Laser1.class);
            }
            break;
            case 5:
            alarm[5] = (short)(300);
            instance_create(96,632,Object500.class);
            instance_create(room_width()-214,632,Object500.class);
            break;
            case 6:
            alarm[6] = (short)(60);
        	Animal animal = instance(Animal.class);
            if (animal != null)
            if (distance_to_object(animal)<512)
            {
                {
                    moog=instance_create(x,y,Object415.class);
                    ((Object415)moog).m=this;
                    moog.setDirection(oghdir);
                }
                oghdir += 45;
                {
                    moog2=instance_create(x,y,Object415.class);
                    ((Object415)moog2).m=this;
                    moog2.setDirection(oghdir);
                }
            }
            if(hspeed != 0 || vspeed != 0)
            	resumeDir = getDirection();
            hspeed = 0;
            vspeed = 0;
            alarm[3] = (short)(15);
            break;
            default:
            super.alarmTriggered(alarmIndex);
            break;
        }
    }
    @Override
    public void handleCollisions()
    {
        for(@SuppressWarnings("unused") Tuudna other : getCollisions(Tuudna.class))
        {
            vspeed=-vspeed;
            if(hspeed != 0 || vspeed != 0)
            	resumeDir = getDirection();
            y=yprevious;
            if(isDisposed())
            return;
        }
        super.handleCollisions();
    }
}
