package owg.lgm.ar1.stuff.invnous;

import owg.lgm.*;
import owg.lgm.ar1.accessories.AR1Fonts;
import owg.lgm.in.KeyEventType;
import owg.lgm.in.KeyListener;
import owg.lgm.in.VK;

import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.GMLib.*;
import static owg.lgm.ar1.accessories.AR1Scripts.*;

public class Allitems extends Entity implements KeyListener
{
	public Allitems(double x, double y)
	{
		super(x, y, 0, false, true, false, null, null);
	}
	protected Allitems(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
	{
		super(x, y, depth, persistent, visible, solid, sprite, mask);
	}

	@Override
	public void render()
	{
		//This is gonna be one heck of a drawing event.
		draw_set_font(AR1Fonts.A_16);
		draw_set_color(c_black);
		draw_text(0, 0, "PRESS ENTER TO RETURN TO GAME.");
		if (global.element1>0)
			draw_sprite(Sprite.get("jewat"),-1,16,64);
		if (global.element2>0)
			draw_sprite(Sprite.get("jewfir"),-1,48,64);
		if (global.element3>0)
			draw_sprite(Sprite.get("jearth"),-1,80,64);
		if (global.element4>0)
			draw_sprite(Sprite.get("jewari"),-1,112,64);
		if (global.robopartsouv==2)
			draw_sprite(Sprite.get("upd"),-1,620,64);
		if (global.blackmushz==2)
			draw_sprite(Sprite.get("sprite311"),-1,620,128);
		if (global.blunuky1>0)
			draw_sprite(Sprite.get("blukyyezz"),-1,16,96);
		if (global.blunuky2>0)
			draw_sprite(Sprite.get("blukyyezz"),-1,48,96);
		if (global.blunuky3>0)
			draw_sprite(Sprite.get("blukyyezz"),-1,80,96);
		if (global.opennewye3>0)
		{
			draw_sprite(Sprite.get("jussad"),-1,16,96);
			draw_sprite(Sprite.get("jussad"),-1,48,96);
			draw_sprite(Sprite.get("jussad"),-1,80,96);
		}
		if (global.thekicard==1)
			draw_sprite(Sprite.get("kycard"),-1,112,96);
		if (global.batters==1)
			draw_sprite(Sprite.get("battriez"),-1,16,128);
		if (global.bigknew1>0)
			draw_sprite(Sprite.get("wrappiecs"),1,48,400);
		if (global.bigknew2>0)
			draw_sprite(Sprite.get("wrappiecs"),2,48,400);
		if (global.bigknew3>0)
			draw_sprite(Sprite.get("wrappiecs"),3,48,400);
		if (global.nwhathevva==2)
			draw_sprite(Sprite.get("sprite319"),-1,144,96);
		if (global.bigknewblu1>0)
			draw_sprite(Sprite.get("kardpiecs"),1,144,400);
		if (global.bigknewblu2>0)
			draw_sprite(Sprite.get("kardpiecs"),2,144,400);
		if (global.bigknewblu3>0)
			draw_sprite(Sprite.get("kardpiecs"),3,144,400);
		if (global.bigk1>0)
			draw_sprite(Sprite.get("piecsofbig"),1,240,400);
		if (global.bigk2>0)
			draw_sprite(Sprite.get("piecsofbig"),2,240,400);
		if (global.bigk3>0)
			draw_sprite(Sprite.get("piecsofbig"),3,240,400);
		if (global.bigk4>0)
			draw_sprite(Sprite.get("piecsofbig"),4,240,400);
		if (global.newkeytak1>0)
			draw_sprite(Sprite.get("keyser"),-1,16,164);
		if (global.newkeytak2>0)
			draw_sprite(Sprite.get("keyser"),-1,48,164);
		if (global.newkeytak3>0)
			draw_sprite(Sprite.get("keyser"),-1,80,164);
		if (global.newkeytak4>0)
			draw_sprite(Sprite.get("keyser"),-1,112,164);
		if (global.opennew>0)
		{
			draw_sprite(Sprite.get("jussad"),-1,16,160);
			draw_sprite(Sprite.get("jussad"),-1,48,160);
			draw_sprite(Sprite.get("jussad"),-1,80,160);
		}
		if (global.keytak1>0)
			draw_sprite(Sprite.get("sprite195"),-1,16,192);
		if (global.keytak2>0)
			draw_sprite(Sprite.get("sprite195"),-1,48,192);
		if (global.keytak3>0)
			draw_sprite(Sprite.get("sprite195"),-1,80,192);
		if (global.keytak4>0)
			draw_sprite(Sprite.get("sprite195"),-1,112,192);
		if (global.opendjung>0)
		{
			draw_sprite(Sprite.get("jussad"),-1,16,192);
			draw_sprite(Sprite.get("jussad"),-1,48,192);
			draw_sprite(Sprite.get("jussad"),-1,80,192);
			draw_sprite(Sprite.get("jussad"),-1,112,192);
		}
		if (global.inngrodd1==1)
			draw_sprite(Sprite.get("ingredient1"),-1,16,224);
		if (global.inngrodd2==1)
			draw_sprite(Sprite.get("ing2"),-1,48,224);
		if (global.inngrodd3==1)
			draw_sprite(Sprite.get("ing3"),-1,80,224);
		if (global.inngrodd4==1)
			draw_sprite(Sprite.get("ing4"),-1,16,256);
		if (global.inngrodd5==1)
			draw_sprite(Sprite.get("ing5"),-1,48,256);
		if (global.inngrodd6==1)
			draw_sprite(Sprite.get("ing6"),-1,80,256);
		if (global.oddkey1>0)
			draw_sprite(Sprite.get("rotpiecs"),1,339,400);
		if (global.oddkey2>0)
			draw_sprite(Sprite.get("rotpiecs"),2,339,400);
		if (global.oddkey3>0)
			draw_sprite(Sprite.get("rotpiecs"),3,339,400);
		if (global.elementye>0)
			draw_sprite(Sprite.get("elmkey"),3,470,400);
	}
	@Override
	public void keyEvent(KeyEventType type, VK key)
	{
		switch (type)
		{
		case PRESS:
			switch (key)
			{
			case ENTER:
				loadTemp();
				break;
			default:
				super.keyEvent(type, key);
				break;
			}
			break;
		default:
			super.keyEvent(type, key);
			break;
		}
	}
}
