package owg.lgm.ar1.stuff.special;

import owg.lgm.*;
import owg.lgm.ar1.accessories.AR1Dialog;
import owg.lgm.ar1.stuff.fakings.Destabl;
import owg.lgm.ar1.stuff.fakings.Destabl2;

import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.GMLib.*;

public class Bornobatt extends Entity implements Collider
{
    public Bornobatt(double x, double y)
    {
        super(x, y, 0, false, true, false, "bore", null);
    }
    protected Bornobatt(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
    {
        super(x, y, depth, persistent, visible, solid, sprite, mask);
    }
    @Override
    public void createEvent()
    {
        /*other.*/image_speed = 0; // ??
        if (global.batters==2)
        {
            destroy();
            instance_destroy_all(Destabl.class);
            instance_destroy_all(Destabl2.class);
        }
    }
    @Override
    public void handleCollisions()
    {
        for(Destabl other : getCollisions(Destabl.class))
        {
            other.destroy();
            sound_play("crash");
    		new AR1Dialog()
    		{
    			@Override
    			public void dialog() throws ConverseException
    			{
    				sleep(50);
    			}
    		}.start();
            if(isDisposed())
            return;
        }
        for(Destabl2 other : getCollisions(Destabl2.class))
        {
        	other.destroy();
            sound_play("crash");
    		new AR1Dialog()
    		{
    			@Override
    			public void dialog() throws ConverseException
    			{
    				sleep(50);
    			}
    		}.start();
            if(isDisposed())
            return;
        }
        super.handleCollisions();
    }
}
