package owg.lgm.ar1;

import owg.lgm.Entity;

public abstract class Invable extends Entity
{
	public Invable(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String spriteName, String maskName)
	{
		super(x, y, depth, persistent, visible, solid, spriteName, maskName);
	}
	
	public int inv;
	public double life;

    @Override
    public void endStep()
    {
        doInvulnerability();
    }

	protected void doInvulnerability()
	{
		if (inv>0)
        {
            inv += -1;
            visible = !visible;
        }
        else
        	visible = true;
	}
}
