package owg.lgm.ar1;

import static owg.lgm.ar1.accessories.AR1Scripts.midi;
import static owg.lgm.ar1.accessories.AR1Globals.global;

import owg.lgm.ar1.accessories.AR1Dialog;
import owg.lgm.ar1.enemy.Object528;
import owg.lgm.ar1.stuff.animals.Evilguy;

import static owg.lgm.GMLib.*;

public class Object524 extends Invable
{
    public Object524(double x, double y)
    {
        super(x, y, 0, false, true, false, "sprite326", null);
    }
    protected Object524(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
    {
        super(x, y, depth, persistent, visible, solid, sprite, mask);
    }
    
    @Override
    public void createEvent()
    {
        life = 10;
        inv = 0;
    }
    @Override
    public void step()
    {
        image_single(life);
        if (life<0)
        {
            destroy();
            instance_destroy_all(Object528.class);
            new AR1Dialog()
			{
				
				@Override
				public void dialog() throws ConverseException
				{
		            show_message("NO!");
		            Evilguy evilguy = instance(Evilguy.class);
		            if(evilguy != null)
		            {
		                instance_create(evilguy.x+0,evilguy.y+0,Object527.class);
		            	evilguy.destroy();
		            }
		            sound_play("badstart");
	                sound_stop_all();
	                global.mzc = null;
	            	midi.midiStop();
				}
			}.start();
        }
    }
}
