package owg.lgm.ar1.back;

import owg.lgm.ar1.stuff.boss.HEVE1;
import owg.lgm.ar1.stuff.evilballstuf.Nodangrit;

import static owg.lgm.GMLib.*;

public class Backtothwl extends HEVE1
{
    public Backtothwl(double x, double y)
    {
        super(x, y, 1, false, false, false, "sprite229", null);
    }
    protected Backtothwl(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
    {
        super(x, y, depth, persistent, visible, solid, sprite, mask);
    }
    
    double dir1, dirsp;
    double sp, spsp;
    Nodangrit moog;
    
    @Override
    public void createEvent()
    {
        inv = 0;
        he = 0;
        ve = 0;
        life = 6;
        dir1 = 270;
        dirsp = 1;
        sp = 64;
        spsp = 0;
        moog = instance_create(x,y,Nodangrit.class);
        moog.m=this;
        alarm[1] = (short)(60);
    }
    @Override
    public void step()
    {
        sp += spsp;
        dir1 += dirsp;
        he = lengthdir_x(sp, dir1);
        ve = lengthdir_y(sp, dir1);
    }
    @Override
    public void render()
    {
        draw_sprite(sprite,image_index,x+0,y+0);
    }
    @Override
    public void alarmTriggered(int alarmIndex)
    {
        switch (alarmIndex)
        {
            case 0:
            if(moog != null)
            {
            	moog.destroy();
            	moog = null;
            }
            destroy();
            break;
            case 1:
            dirsp = 10;
            alarm[2] = (short)(30+random(30));
            break;
            case 2:
            dirsp = 1;
            alarm[1] = (short)(60);
            break;
            default:
            super.alarmTriggered(alarmIndex);
            break;
        }
    }
}
