package owg.lgm.ar1.map;

import static owg.lgm.GMLib.*;
import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.ar1.accessories.AR1Scripts.*;

import owg.lgm.Entity;
import owg.lgm.ar1.accessories.AR1Fonts;
import owg.lgm.in.KeyEventType;
import owg.lgm.in.KeyListener;
import owg.lgm.in.VK;
import owg.lgm.room.Room;
import owg.lgm.room.Room.ViewData;

public class Mapobj extends Entity implements KeyListener
{
    public Mapobj(double x, double y)
    {
        super(x, y, -1, false, true, false, null, null);
    }
    protected Mapobj(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
    {
        super(x, y, depth, persistent, visible, solid, sprite, mask);
    }
    @Override
    public void createEvent()
    {
        if (global.stairbeen==0)
        {
        	Room.CURRENT.tiles.setVisible(10006958, false);
        }
        instance_create(0,0,Mapscroll.class);
    }
    @Override
    public void render()
    {
        draw_set_font(AR1Fonts.A_16);
        draw_set_color(c_black);
        ViewData view = Room.CURRENT.views[Room.CURRENT.getViewIndex()];
        draw_text(view.xview, view.yview, "PRESS ENTER TO RETURN TO GAME.");
        draw_text(view.xview, view.yview+32, "Use arrows to navigate the map.");
    }
    @Override
    public void keyEvent(KeyEventType type, VK key)
    {
        switch (type)
        {
            case PRESS:
            switch (key)
            {
                case ENTER:
                loadTemp();
                break;
                default:
                super.keyEvent(type, key);
                break;
            }
            break;
            default:
            super.keyEvent(type, key);
            break;
        }
    }
}
