package owg.lgm.ar1.map;

import owg.lgm.*;
import owg.lgm.in.KeyEventType;
import owg.lgm.in.KeyListener;
import owg.lgm.in.VK;
import owg.lgm.room.Room;
import owg.lgm.room.Room.ViewData;

import static owg.lgm.GMLib.*;

public class Mapscroll extends Entity implements KeyListener
{
    public Mapscroll(double x, double y)
    {
        super(x, y, 0, false, false, false, "lava", null);
    }
    protected Mapscroll(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
    {
        super(x, y, depth, persistent, visible, solid, sprite, mask);
    }
    @Override
    public void keyEvent(KeyEventType type, VK key)
    {
        ViewData view = Room.CURRENT.views[Room.CURRENT.getViewIndex()];
        switch (type)
        {
            case DOWN:
            switch (key)
            {
                case LEFT:
                {
                    if(view.xview>0)
                    view.xview-=10;
                }
                break;
                case UP:
                {
                    if(view.yview>0)
                    view.yview-=10;
                }
                break;
                case RIGHT:
                {
                    if(view.xview<room_width()-640)
                    view.xview+=10;
                }
                break;
                case DOWN:
                {
                    if(view.yview<room_height()-480)
                    view.yview+=10;
                }
                break;
                default:
                super.keyEvent(type, key);
                break;
            }
            break;
            default:
            super.keyEvent(type, key);
            break;
        }
    }
}
