package owg.lgm.ar1.stuff.animals;

import owg.lgm.*;
import owg.lgm.ar1.Animal;
import owg.lgm.ar1.accessories.AR1Dialog;
import owg.lgm.ar1.kyz.Kylier2;

import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.GMLib.*;

public class Medguyd extends Entity
{
	public Medguyd(double x, double y)
	{
		super(x, y, 0, false, true, false, "medguy", null);
	}
	protected Medguyd(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
	{
		super(x, y, depth, persistent, visible, solid, sprite, mask);
	}
	@Override
	public void createEvent()
	{
		if (global.newkeytak2==0)
			alarm[0] = (short)(30);
		else
		{
			sprite = Sprite.get("sprite230");
			image_xscale=1;
			image_yscale=1;
		}
	}
	@Override
	public void alarmTriggered(int alarmIndex)
	{
		Animal animal = instance(Animal.class);
		switch (alarmIndex)
		{
		case 0:
			new AR1Dialog()
			{
				@Override
				public void dialog() throws ConverseException, SleepException
				{
					show_message("Dont kill me!");
					animal.still = 1;
					animal.hspeed=4;
					alarm[1] = (short)(90);
					animal.friction=0;
					alarm[3] = (short)(20);
					animal.alarm[0] = (short)(20);
					animal.image_speed = animal.hspeed/3;
					if (global.cha==0)
					{
						animal.sprite = Sprite.get("ywalkr");
						animal.image_xscale=1;
						animal.image_yscale=1;
					}
					if (global.cha==1)
					{
						animal.sprite = Sprite.get("kwalkr");
						animal.image_xscale=1;
						animal.image_yscale=1;
					}
					if (global.cha==2)
					{
						animal.sprite = Sprite.get("fwalkr");
						animal.image_xscale=1;
						animal.image_yscale=1;
					}
				}
			}.start();
			break;
		case 1:
			new AR1Dialog()
			{

				@Override
				public void dialog() throws ConverseException, SleepException
				{
					show_message("Thank you! You saved me!");
					show_message("Living here has become dangerous! This part of the jungle is always full of metal monsters!");
					show_message("Come by anytime if you are low on health.");
					show_message("You can have this key. I dont know what its for, but maybe you can use it.");
					instance_create(x+0,y+-12,Kylier2.class);
					alarm[2] = (short)(60);
				}
			}.start();
			break;
		case 2:
			animal.still = 0;
			break;
		case 3:
			animal.friction=0.30;
			break;
		default:
			super.alarmTriggered(alarmIndex);
			break;
		}
	}
}
