package owg.lgm.ar1.stuff.boss;

import owg.lgm.ar1.Invable;
import owg.lgm.ar1.enemy.Laser1;
import owg.lgm.ar1.fallers.Fall55;

import static owg.lgm.GMLib.*;

public class Lockboss2 extends Invable
{
	public Lockboss2(double x, double y)
	{
		super(x, y, 0, false, true, false, "lockon1", null);
	}
	protected Lockboss2(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
	{
		super(x, y, depth, persistent, visible, solid, sprite, mask);
	}
	@Override
	public void createEvent()
	{
		inv = 0;
		life = 65;
		alarm[1] = (short)(18);
	}
	@Override
	public void step()
	{
		//dass
	}
	@Override
	public void alarmTriggered(int alarmIndex)
	{
		switch (alarmIndex)
		{
		case 0:
			destroy();
			if (floor(random(2-1))==0)
				instance_create(x+0,y+0,Fall55.class);
			{
				Doorlockd1 doorlockd1 = instance_nearest(x,y,Doorlockd1.class);
				if(doorlockd1 != null)
					doorlockd1.destroy();
			}
			{
				Doorlockd2 doorlockd2 = instance_nearest(x,y,Doorlockd2.class);
				if(doorlockd2 != null)
					doorlockd2.destroy();
			}
			break;
		case 1:
			alarm[1] = (short)(life+30+random(90));
			if (instance_number(Lockboss1.class)==0)
				instance_create(x+64,y+0,Laser1.class);
			break;
		default:
			super.alarmTriggered(alarmIndex);
			break;
		}
	}
}
